// ------------------------------------------------------------------------------
//  <auto-generated>
//     This code was generated from a template.
// 
//     Manual changes to this file will be overwritten if the code is regenerated.
//
//     Generated on 2017-07-07T14:57:14, by ESR Version 1.65.0.0 using ESR Database 
//  </auto-generated>
// ------------------------------------------------------------------------------

using System;
using System.IO;
using System.Runtime.CompilerServices;
using System.Text;
using System.Xml;
using System.Linq;
using System.Collections.Generic;
using Ato.EN.IntegrationServices.Document.DataContracts;
using System.Text.RegularExpressions;
using Ato.EN.IntegrationServices.CodeGenerationEPMTSYSTXCLNTREQUEST2017;

namespace Ato.EN.IntegrationServices.CodeGenerationEPMTSYSTXREQUEST2017
{
    public static class CustomExtensionMethods
    {
        public static string GetValueOrEmpty(this bool? val)
        {
            return (val != null) ? val.ToString() : string.Empty;
        }

        public static string GetValueOrEmpty(this DateTime? val)
        {
            return (val != null) ? val.ToString() : string.Empty;
        }
    }

    public partial class EPMTSYSTXREQUEST2017Validator
    {
        /// <summary>
        /// The max parameter name length is restricted by the SBR1 and SBR2 schemas - the lowest common denominator of SBR 1 is used as the default
        /// </summary>
        private int _maxParameterNameLength;

        /// <summary>
        /// The max parameter value length is restricted by the SBR1 and SBR2 schemas
        /// </summary>
        private int _maxParameterValueLength;

        /// <summary>
        /// The SBR1 and ebms3 schemas do not allow parameter names or values to be the empty string
        /// </summary>
        private string _emptyParameterValue;

        public ProcessMessageSeverity MaximumSeverity { get; set; }

        public ProcessMessageSeverity MaximumSeverityCrossForm { get; set; }

        /// <summary>
        /// Initializes a new instance of the <see cref="EPMTSYSTXREQUEST2017Validator" /> class.
        /// </summary>
        /// <param name="maxParameterNameLength">Maximum length of the parameter name.</param>
        /// <param name="maxParameterValueLength">Maximum length of the parameter value.</param>
        /// <param name="emptyParameterValue">This value will be used in place of any parameter values that result in a null or empty value.</param>
        public EPMTSYSTXREQUEST2017Validator(int maxParameterNameLength = 20, int maxParameterValueLength = 4096, string emptyParameterValue = "EMPTY")
        {
            _maxParameterNameLength = maxParameterNameLength;
            _maxParameterValueLength = maxParameterValueLength;
            _emptyParameterValue = emptyParameterValue;
        }

        #region Functions
        private static IEnumerable<string> Union(IEnumerable<string> list1, IEnumerable<string> list2)
        {
            IEnumerable<string> response;

            if (list1 == null && list2 == null)
            {
                response = null;
            }
            else if (list1 == null)
            {
                response = list2.Distinct();
            }
            else if (list2 == null)
            {
                response = list1.Distinct();
            }
            else
            {
                response = list1.Union(list2);
            }

            return response;
        }

        private static bool IsMatch(int? field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(Convert.ToString(field.Value), expression, options);
        }

        private static bool IsMatch(string field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(field, expression, options);
        }

        // This is just context and tuple counts where they are integer values - easier that changing the parsing logic to just return the value
        private static int Count(int count)
        {
            return count;
        }


        private static int Count<T>(IEnumerable<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static int Count<T>(ICollection<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static bool exists(bool value)
        {
            return value;
        }

        private static string GetValueOrEmpty(bool? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        private static string GetValueOrEmpty(DateTime? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        /// <summary>
        /// Get string value between [first] a and [last] b.
        /// </summary>
        public static string Between(string value, string a, string b)
        {
            int posA = value.IndexOf(a);
            int posB = value.LastIndexOf(b);
            if (posA == -1)
            {
                return "";
            }
            if (posB == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= posB)
            {
                return "";
            }
            return value.Substring(adjustedPosA, posB - adjustedPosA);
        }

        /// <summary>
        /// Get string value after [first] a.
        /// </summary>
        public static string Before(string value, string a)
        {
            int posA = value.IndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            return value.Substring(0, posA);
        }

        /// <summary>
        /// Get string value after [last] a.
        /// </summary>
        public static string After(string value, string a)
        {
            int posA = value.LastIndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= value.Length)
            {
                return "";
            }
            return value.Substring(adjustedPosA);
        }

        private static int Length(object field)
        {
            if (field == null)
                return 0;
            else
                return field.ToString().Trim().Length;
        }

        private static bool NotSameValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return NotSameValues(nodesArray);
        }

        private static bool NotSameValues(params object[] nodes)
        {
            if (nodes == null)
                return false;

            return ((from x in nodes select x).Distinct().Count() == nodes.Count());
        }

        private static bool HasDuplicateValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return HasDuplicateValues(nodesArray);
        }

        private static bool HasDuplicateValues(params object[] nodes)
        {
            if (nodes == null)
                return false;

            return !((from x in nodes select x).Distinct().Count() == nodes.Count());
        }

        private int DuplicateValueIndex(IEnumerable<object> values)
        {
            int response = 0;
            var hashset = new HashSet<object>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private int DuplicateValueIndex<T>(IEnumerable<T?> values) where T : struct
        {
            int response = 0;
            var hashset = new HashSet<T?>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private static bool IsDate(object value)
        {
            DateTime dateValue;
            return (value != null && DateTime.TryParse(value.ToString(), out dateValue));
        }

        public DateTime AsDate(string dateAsString)
        {
            DateTime response = DateTime.MinValue;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date;
            }

            return response;
        }
        //The logic in After function expects "---" for day and "--" for month. 
        //Since hyphen was missing the date always returned null
        public DateTime? ConvertToDate(int day, int month, int year)
        {
            return ConvertToDate(day == 0 ? null : "---" + day.ToString(), month == 0 ? null : "--" + month.ToString(), year == 0 ? null : year.ToString());
        }

        public DateTime? ConvertToDate(string day, string month, string year)
        {
            DateTime? response;
            DateTime result;

            if (year == null || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        public DateTime? ConvertToDate(string day, string month, int year)
        {
            DateTime? response;
            DateTime result;

            if (year == 0 || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year.ToString() + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        private static int Day(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Day;
            }

            return response;
        }


        private static int Day(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Day;

        }


        private static string Month(string dateAsString)
        {
            string response = null;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.ToString("MMMM");
            }
            else
            {
                return "NotAMonth";
            }

            return response;
        }

        private static string Month(DateTime? date)
        {
            if (date == null)
                return "NotAMonth";
            else
                return date.Value.ToString("MMMM");
        }


        private static int MonthAsInt(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Month;
            }

            return response;
        }

        private static int MonthAsInt(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            return date.Value.Month;
        }


        private static int Year(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Year;
            }

            return response;
        }

        private static int Year(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Year;
        }


        private static int CurrentFinancialYear()
        {
            return DateToFinancialYear(DateTime.Now, 7);
        }

        private static int FinancialYear(string dateAsString)
        {
            return DateToFinancialYear(dateAsString, 7);
        }

        private static int FinancialYear(DateTime? date)
        {
            return DateToFinancialYear(date, 7);
        }

        private static int DateToFinancialYear(string dateAsString, int startingMonth)
        {
            int response = 0;
            DateTime date;
            if (DateTime.TryParse(dateAsString, out date))
            {
                response = DateToFinancialYear(date, startingMonth);
            }

            return response;
        }
        private static int DateToFinancialYear(DateTime? date, int startingMonth)
        {
            int response;
            if (date == null)
            {
                response = 0;
            }
            else
            {
                int year = date.Value.Year;
                int month = date.Value.Month;

                if (startingMonth > month)
                    response = year;
                else
                    response = year + 1;
            }
            return response;
        }


        private static int FBTYear(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
                response = FBTYear(date);
            return response;
        }

        private static int FBTYear(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            else
            {
                if (date.Value.Month > 3)
                    return date.Value.Year + 1;
                else
                    return date.Value.Year;
            }
        }


        private static bool IsNumeric(object value)
        {
            decimal numbervalue;
            return (value != null && decimal.TryParse(value.ToString(), out numbervalue));
        }

        private static bool NotMonetary(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(int? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }

        private static bool NotNumeric(long? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }


        private static bool OutsideRange(decimal field, decimal expression, int range)
        {
            bool response;

            response = (field < (expression - range)) || (field > (expression + range));

            return response;
        }


        private static bool FailsUSIAlgorithm(string usi, string abn)
        {
            bool response;
            if (usi == null || abn == null)
            {
                response = false;
            }
            else
            {
                usi = usi.Trim();
                abn = abn.Trim();
                if (usi.Length < 13 || abn.Length < 11)
                {
                    response = false;
                }
                else
                {
                    int numeric;
                    if (usi.Substring(0, 11) == abn && int.TryParse(usi.Substring(11, 2), out numeric))
                        response = false;
                    else if (Regex.IsMatch(usi, @"^[a-zA-Z]{3}\d{4}[a-zA-Z]{2}"))
                        response = false;
                    else
                        response = true;
                }
            }
            return response;
        }


        private static bool FailsTANAlgorithm(string tan)
        {
            bool response;
            decimal decimalTan;

            if (tan == null)
                return false;

            tan = tan.Trim();

            if (!decimal.TryParse(tan, out decimalTan))
                return true;

            if (tan.Length != 8)
                return true;

            decimal tanSum =
                7 * int.Parse(tan.Substring(0, 1)) +
                9 * int.Parse(tan.Substring(1, 1)) +
                8 * int.Parse(tan.Substring(2, 1)) +
                4 * int.Parse(tan.Substring(3, 1)) +
                6 * int.Parse(tan.Substring(4, 1)) +
                3 * int.Parse(tan.Substring(5, 1)) +
                5 * int.Parse(tan.Substring(6, 1)) +
                1 * int.Parse(tan.Substring(7, 1));

            if ((tanSum % 11) == 0)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsABNAlgorithm(string abn)
        {
            bool response;
            decimal decimalAbn;

            if (abn == null)
                return false;

            abn = abn.Trim();

            if (!decimal.TryParse(abn, out decimalAbn))
                return true;

            if (abn.Length != 11)
                return true;

            decimal abnSum =
                10 * (int.Parse(abn.Substring(0, 1)) - 1) +
                1 * int.Parse(abn.Substring(1, 1)) +
                3 * int.Parse(abn.Substring(2, 1)) +
                5 * int.Parse(abn.Substring(3, 1)) +
                7 * int.Parse(abn.Substring(4, 1)) +
                9 * int.Parse(abn.Substring(5, 1)) +
                11 * int.Parse(abn.Substring(6, 1)) +
                13 * int.Parse(abn.Substring(7, 1)) +
                15 * int.Parse(abn.Substring(8, 1)) +
                17 * int.Parse(abn.Substring(9, 1)) +
                19 * int.Parse(abn.Substring(10, 1));

            if ((abnSum % 89) == 0)
                response = false;
            else
                response = true;

            return response;
        }
        private static bool FailsACNAlgorithm(string acn)
        {
            bool response;
            decimal decimalAbn;
            if (acn == null)
                return false;

            acn = acn.Trim();

            if (!decimal.TryParse(acn, out decimalAbn))
                return true;

            if (acn.Length != 9)
                return true;

            decimal abnSum =
                8 * int.Parse(acn.Substring(0, 1)) +
                7 * int.Parse(acn.Substring(1, 1)) +
                6 * int.Parse(acn.Substring(2, 1)) +
                5 * int.Parse(acn.Substring(3, 1)) +
                4 * int.Parse(acn.Substring(4, 1)) +
                3 * int.Parse(acn.Substring(5, 1)) +
                2 * int.Parse(acn.Substring(6, 1)) +
                1 * int.Parse(acn.Substring(7, 1));

            decimal checkDigit = int.Parse(acn.Substring(8, 1));
            decimal acnRemainder = abnSum % 10;

            if (((10 - acnRemainder) % 10) == checkDigit)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsTFNAlgorithm(string tfn)
        {
            bool response;
            decimal decimalTfn;

            if (tfn == null)
                return false;

            tfn = tfn.Trim();
            tfn = Regex.Replace(tfn, "^0+", "");

            if (!decimal.TryParse(tfn, out decimalTfn))
                return true;

            if (tfn.Length < 8)
                return true;


            decimal tfn1To7Sum =
                1 * int.Parse(tfn.Substring(0, 1)) +
                4 * int.Parse(tfn.Substring(1, 1)) +
                3 * int.Parse(tfn.Substring(2, 1)) +
                7 * int.Parse(tfn.Substring(3, 1)) +
                5 * int.Parse(tfn.Substring(4, 1)) +
                8 * int.Parse(tfn.Substring(5, 1)) +
                6 * int.Parse(tfn.Substring(6, 1));

            decimal tfn8 = 9 * int.Parse(tfn.Substring(7, 1));

            if (tfn.Length == 8)
            {
                decimal tFNLg8WSum9 = 10 * int.Parse(tfn.Substring(7, 1));
                decimal tFNLg8WSum = tfn1To7Sum + tFNLg8WSum9;

                if ((tFNLg8WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else if (tfn.Length == 9)
            {
                decimal tfn9 = 10 * int.Parse(tfn.Substring(8, 1));
                decimal tFNLg9WSum = tfn1To7Sum + tfn8 + tfn9;

                if ((tFNLg9WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else
            {
                response = true;
            }

            return response;
        }


        private static decimal ConditionalValue(bool expression, decimal? trueVal, decimal? falseVal)
        {
            return expression ? trueVal.GetValueOrDefault() : falseVal.GetValueOrDefault();
        }

        private static decimal AsNumeric(string value)
        {
            decimal numberValue;
            decimal.TryParse(value, out numberValue);
            return numberValue;
        }

        private static bool RegexMatch(int? field, string expression, string flags = "")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static bool RegexMatch(string field, string expression, string flags = "")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static RegexOptions GetRegexOption(string flags)
        {
            RegexOptions options = RegexOptions.None;

            char[] characters = flags.ToCharArray();

            foreach (char character in characters)
            {
                switch (character)
                {
                    case 'i':
                        options = options | RegexOptions.IgnoreCase;
                        break;
                    case 'm':
                        options = options | RegexOptions.Multiline;
                        break;
                    case 's':
                        options = options | RegexOptions.Singleline;
                        break;
                    case 'n':
                        options = options | RegexOptions.ExplicitCapture;
                        break;
                    case 'x':
                        options = options | RegexOptions.IgnorePatternWhitespace;
                        break;
                }
            }

            return options;
        }

        #region CloneMessage
        private static ProcessMessageDocument CloneMessage(ProcessMessageDocument document)
        {
            if (document == null) return null;
            ProcessMessageDocument response = new ProcessMessageDocument
            {
                CategoryCode = document.CategoryCode,
                Code = document.Code,
                Description = document.Description,
                DocumentSequence = document.DocumentSequence,
                Location = document.Location,
                LongDescription = document.LongDescription,
                PropertyName = document.PropertyName,
                Severity = document.Severity,
                SeverityAsString = document.SeverityAsString,
                suppress = document.suppress,
                Parameters = new ProcessMessageParameters()
            };

            foreach (ProcessMessageParameter param in document.Parameters)
            {
                var parameter = new ProcessMessageParameter
                {
                    Name = param.Name,
                    Value = param.Value
                };
                response.Parameters.Add(parameter);
            }

            return response;
        }
        #endregion

        /// <summary>
        /// Returns an occurrence index as [occurrenceIndex] of occurrenceIndex > 0, otherwise the empty string
        /// </summary>
        /// <param name="occurrenceIndex">Index of the occurrence.</param>
        /// <returns>Occurrence in XPath [#] format</returns>
        public string OccurrenceIndex(int occurrenceIndex)
        {
            return occurrenceIndex > 0 ? "[" + occurrenceIndex + "]" : "";
        }

        #endregion // Functions

        public EPMTSYSTXREQUEST2017 ConsumedReport { get; private set; }
        public EPMTSYSTXCLNTREQUEST2017 ConsumedChildReport { get; private set; }

        private static Dictionary<string, ProcessMessageDocument> _processMessageDocuments = new Dictionary<string, ProcessMessageDocument>();

        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        public List<ProcessMessageDocument> ValidateReport(EPMTSYSTXREQUEST2017 report, bool isXbrl = true)
        {

            List<ProcessMessageDocument> response = new List<ProcessMessageDocument>();
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            bool assertion;
            
            ProcessMessageSeverity maxSeverity = ProcessMessageSeverity.Progressive;
            this.MaximumSeverity = ProcessMessageSeverity.Progressive;

            this.ConsumedReport = report;

            // ------------------------------------------------------------------------------
            // Validations are now done in code.
            // This version supports full validation of a report - for those rules that have successfully parsed and could be generated.
            // Generated Validations include:
            //   - Validation logic in C#.
            //   - Production of errors in EBMS, SBR and SWS format.
            // 
            // The generation at this stage does not support the following - and has to be completed manually (later versions of the generation will do this for you)
            //   - Business Rules that did not parse.  The ESR team will help support you where this happens as an effort is being made to rectify these
            //   - You will get TODO tasks for those that the parser could not cope with
            // ------------------------------------------------------------------------------

            #region Non Cross Form Rules

            #region VR.ATO.EPMTSYSTX.000002

            /*  VR.ATO.EPMTSYSTX.000002
            Intermediary Australian Business Number (ABN) has failed the ABN algorithm check.
    
            Legacy Rule Format:
            FailsABNAlgorithm(^EPMTSYSTX1)

            Technical Business Rule Format:
            FailsABNAlgorithm(^EPMTSYSTX1)
    
            Data Elements:
    
            INT:^EPMTSYSTX1 = pyid.02.00:Identifiers.AustralianBusinessNumber.Identifier
            */
            assertion = FailsABNAlgorithm(report.EPMTSYSTX1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000101",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid ABN",
                    LongDescription = @"The Australian Business Number field must contain a valid Australian Business Number.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:INT/tns:IdentifiersAustralianBusinessNumberIdentifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000002" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX1", Value = report.EPMTSYSTX1 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000002

            #region VR.ATO.EPMTSYSTX.000003

            /*  VR.ATO.EPMTSYSTX.000003
            Date timestamp report commencement date cannot be any day in the future.
    
            Legacy Rule Format:
            (ConvertToDate(1, 7, 2017) <= Today()) AND (^EPMTSYSTX45 > Today())

            Technical Business Rule Format:
            (ConvertToDate(1, 7, 2017) <= Today()) AND (^EPMTSYSTX45 > Today())
    
            Data Elements:
    
            INT:^EPMTSYSTX45 = pyin.02.00:BusinessDocument.Creation.Datetime
            */
            assertion = (ConvertToDate(1, 7, 2017) <= DateTime.Now.Date && report.EPMTSYSTX45.GetValueOrDefault().Date > DateTime.Now.Date);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000116",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid date",
                    LongDescription = @"Date timestamp report created must not be a future date.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:INT/tns:BusinessDocumentCreationDatetime",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000003" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX45", Value = GetValueOrEmpty(report.EPMTSYSTX45) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000003

            #region VR.ATO.EPMTSYSTX.000004

            /*  VR.ATO.EPMTSYSTX.000004
            For an International phone number, this field must not be present.
    
            Legacy Rule Format:
            (^EPMTSYSTX42 = TRUE AND ^EPMTSYSTX5 <> NULL)

            Technical Business Rule Format:
            ^EPMTSYSTX42 = TRUE AND ^EPMTSYSTX5 <> NULL
    
            Data Elements:
    
            INT.PrimaryContact:^EPMTSYSTX5 = pyde.02.00:ElectronicContact.Telephone.Area.Code
    
            INT.AddressDetails.Business:^EPMTSYSTX42 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX42 == true && report.EPMTSYSTX5 != null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000131",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must not be present",
                    LongDescription = @"When the address is overseas, the Area Code must be blank.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:INT/tns:PrimaryContact/tns:ElectronicContactTelephoneAreaCode",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000004" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX42", Value = GetValueOrEmpty(report.EPMTSYSTX42) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX5", Value = report.EPMTSYSTX5 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000004

            #region VR.ATO.EPMTSYSTX.000007

            /*  VR.ATO.EPMTSYSTX.000007
            Intermediary address line one must be present.
    
            Legacy Rule Format:
            (^EPMTSYSTX8 = BLANK)

            Technical Business Rule Format:
            ^EPMTSYSTX8 = BLANK
    
            Data Elements:
    
            INT.AddressDetails.Business:^EPMTSYSTX8 = pyde.02.00:AddressDetails.Line1.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTX8) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must be present",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:INT/tns:AddressDetailsBusiness/tns:Line1Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000007" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX8", Value = report.EPMTSYSTX8 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000007

            #region VR.ATO.EPMTSYSTX.000010

            /*  VR.ATO.EPMTSYSTX.000010
            Intermediary address suburb, town or locality must be present.
    
            Legacy Rule Format:
            (^EPMTSYSTX10 = BLANK)

            Technical Business Rule Format:
            ^EPMTSYSTX10 = BLANK
    
            Data Elements:
    
            INT.AddressDetails.Business:^EPMTSYSTX10 = pyde.02.00:AddressDetails.LocalityName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTX10) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must be present",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:INT/tns:AddressDetailsBusiness/tns:LocalityNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000010" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX10", Value = report.EPMTSYSTX10 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000010

            #region VR.ATO.EPMTSYSTX.000012

            /*  VR.ATO.EPMTSYSTX.000012
            When the address is within Australia, the Postcode must be in the range of '0200-9998'.
    
            Legacy Rule Format:
            (^EPMTSYSTX42 = FALSE AND (AsNumeric(^EPMTSYSTX12) < 0200 OR AsNumeric(^EPMTSYSTX12) > 9998))

            Technical Business Rule Format:
            (^EPMTSYSTX42 = FALSE AND (AsNumeric(^EPMTSYSTX12) < 0200 OR AsNumeric(^EPMTSYSTX12) > 9998))
    
            Data Elements:
    
            INT.AddressDetails.Business:^EPMTSYSTX12 = pyde.02.00:AddressDetails.Postcode.Text
    
            INT.AddressDetails.Business:^EPMTSYSTX42 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX42 == false && (AsNumeric(report.EPMTSYSTX12) < 200 || AsNumeric(report.EPMTSYSTX12) > 9998));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000127",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"A valid postcode must be supplied",
                    LongDescription = @"When the address is within Australia, the Postcode must be in the range of '0200-9998'.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:INT/tns:AddressDetailsBusiness/tns:PostcodeText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000012" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX42", Value = GetValueOrEmpty(report.EPMTSYSTX42) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX12", Value = report.EPMTSYSTX12 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000012

            #region VR.ATO.EPMTSYSTX.000013

            /*  VR.ATO.EPMTSYSTX.000013
            When the address is overseas, the Postcode must be blank.
    
            Legacy Rule Format:
            (^EPMTSYSTX42 = TRUE AND ^EPMTSYSTX12 <> NULL)

            Technical Business Rule Format:
            ^EPMTSYSTX42 = TRUE AND ^EPMTSYSTX12 <> NULL
    
            Data Elements:
    
            INT.AddressDetails.Business:^EPMTSYSTX12 = pyde.02.00:AddressDetails.Postcode.Text
    
            INT.AddressDetails.Business:^EPMTSYSTX42 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX42 == true && report.EPMTSYSTX12 != null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000128",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Postcode must be left blank",
                    LongDescription = @"When the address is overseas, the Postcode must be blank.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:INT/tns:AddressDetailsBusiness/tns:PostcodeText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000013" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX42", Value = GetValueOrEmpty(report.EPMTSYSTX42) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX12", Value = report.EPMTSYSTX12 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000013

            #region VR.ATO.EPMTSYSTX.000014

            /*  VR.ATO.EPMTSYSTX.000014
            When the address is within Australia, the State / Territory must be a valid state code.
    
            Legacy Rule Format:
            (^EPMTSYSTX42 = FALSE) AND (NotInSet(^EPMTSYSTX11,'"ACT","NSW","NT","QLD","SA","TAS","VIC","WA"'))

            Technical Business Rule Format:
            (^EPMTSYSTX42 = FALSE) AND (NotInSet(^EPMTSYSTX11,'"ACT","NSW","NT","QLD","SA","TAS","VIC","WA"'))
    
            Data Elements:
    
            INT.AddressDetails.Business:^EPMTSYSTX11 = pyde.02.00:AddressDetails.StateOrTerritory.Code
    
            INT.AddressDetails.Business:^EPMTSYSTX42 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX42 == false && !(IsMatch(report.EPMTSYSTX11, @"^(ACT|NSW|NT|QLD|SA|TAS|VIC|WA)$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000125",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"A valid state or territory code must be supplied",
                    LongDescription = @"When the address is within Australia, the State / Territory must be a valid state code.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:INT/tns:AddressDetailsBusiness/tns:StateOrTerritoryCode",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000014" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX42", Value = GetValueOrEmpty(report.EPMTSYSTX42) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX11", Value = report.EPMTSYSTX11 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000014

            #region VR.ATO.EPMTSYSTX.000015

            /*  VR.ATO.EPMTSYSTX.000015
            When the address is overseas, the Country Name cannot be 'AUSTRALIA' or blank.
    
            Legacy Rule Format:
            (^EPMTSYSTX42 = TRUE AND (^EPMTSYSTX14 = NULLORBLANK OR RegexMatch(^EPMTSYSTX14, '^\s*AUSTRALIA\s*$', 'i')))

            Technical Business Rule Format:
            (^EPMTSYSTX42 = TRUE AND (^EPMTSYSTX14 = BLANK OR RegexMatch(^EPMTSYSTX14, '^\s*AUSTRALIA\s*$', 'i')))
    
            Data Elements:
    
            INT.AddressDetails.Business:^EPMTSYSTX14 = pyde.02.08:AddressDetails.CountryName.Text
    
            INT.AddressDetails.Business:^EPMTSYSTX42 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX42 == true && (string.IsNullOrWhiteSpace(report.EPMTSYSTX14) == true || RegexMatch(report.EPMTSYSTX14, @"^\s*AUSTRALIA\s*$", @"i")));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000130",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"A country other than Australia must be entered",
                    LongDescription = @"When the address is overseas, the Country Name cannot be 'AUSTRALIA' or blank.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:INT/tns:AddressDetailsBusiness/tns:CountryNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000015" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX42", Value = GetValueOrEmpty(report.EPMTSYSTX42) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX14", Value = report.EPMTSYSTX14 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000015

            #region VR.ATO.EPMTSYSTX.000016

            /*  VR.ATO.EPMTSYSTX.000016
            Reporting party Australian Business Number(ABN) has failed the ABN algorithm check.
    
            Legacy Rule Format:
            FailsABNAlgorithm(^EPMTSYSTX15)

            Technical Business Rule Format:
            FailsABNAlgorithm(^EPMTSYSTX15)
    
            Data Elements:
    
            RP:^EPMTSYSTX15 = pyid.02.00:Identifiers.AustralianBusinessNumber.Identifier
            */
            assertion = FailsABNAlgorithm(report.EPMTSYSTX15);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000101",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid ABN",
                    LongDescription = @"The Australian Business Number field must contain a valid Australian Business Number.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:IdentifiersAustralianBusinessNumberIdentifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000016" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX15", Value = report.EPMTSYSTX15 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000016

            #region VR.ATO.EPMTSYSTX.000019

            /*  VR.ATO.EPMTSYSTX.000019
            The date reported in the Reporting Period End Date must on or after the date reported in the Reporting Period Start Date.
    
            Legacy Rule Format:
            ^EPMTSYSTX41 < ^EPMTSYSTX40

            Technical Business Rule Format:
            ^EPMTSYSTX41 < ^EPMTSYSTX40
    
            Data Elements:
    
            RP:^EPMTSYSTX41 = pyin.02.00:Period.End.Date
    
            RP:^EPMTSYSTX40 = pyin.02.00:Period.Start.Date
            */
            assertion = (report.EPMTSYSTX41.GetValueOrDefault() < report.EPMTSYSTX40.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000107",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Reporting period end date must be the same or later than the reporting period start date",
                    LongDescription = @"The date reported in the Reporting Period End Date must be on or after the date reported in the Reporting Period Start Date.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:PeriodEndDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000019" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX41", Value = GetValueOrEmpty(report.EPMTSYSTX41) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX40", Value = GetValueOrEmpty(report.EPMTSYSTX40) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000019

            #region VR.ATO.EPMTSYSTX.000021

            /*  VR.ATO.EPMTSYSTX.000021
            For an International phone number, this field must not be present.
    
            Legacy Rule Format:
            (^EPMTSYSTX44 = TRUE AND ^EPMTSYSTX21 <> NULL)

            Technical Business Rule Format:
            ^EPMTSYSTX44 = TRUE AND ^EPMTSYSTX21 <> NULL
    
            Data Elements:
    
            RP.PrimaryContact:^EPMTSYSTX21 = pyde.02.00:ElectronicContact.Telephone.Area.Code
    
            RP.AddressDetails.Business:^EPMTSYSTX44 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX44 == true && report.EPMTSYSTX21 != null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000131",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must not be present",
                    LongDescription = @"When the address is overseas, the Area Code must be blank.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:PrimaryContact/tns:ElectronicContactTelephoneAreaCode",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000021" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX44", Value = GetValueOrEmpty(report.EPMTSYSTX44) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX21", Value = report.EPMTSYSTX21 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000021

            #region VR.ATO.EPMTSYSTX.000029

            /*  VR.ATO.EPMTSYSTX.000029
            Reporting party business address suburb, town or locality must be present.
    
            Legacy Rule Format:
            (^EPMTSYSTX28 = BLANK)

            Technical Business Rule Format:
            ^EPMTSYSTX28 = BLANK
    
            Data Elements:
    
            RP.AddressDetails.Business:^EPMTSYSTX28 = pyde.02.00:AddressDetails.LocalityName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTX28) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must be present",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:AddressDetailsBusiness/tns:LocalityNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000029" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX28", Value = report.EPMTSYSTX28 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000029

            #region VR.ATO.EPMTSYSTX.000030

            /*  VR.ATO.EPMTSYSTX.000030
            When the address is within Australia, the Postcode must be in the range of '0200-9998'.
    
            Legacy Rule Format:
            (^EPMTSYSTX44 = FALSE AND (AsNumeric(^EPMTSYSTX30) < 0200 OR AsNumeric(^EPMTSYSTX30) > 9998))

            Technical Business Rule Format:
            (^EPMTSYSTX44 = FALSE AND (AsNumeric(^EPMTSYSTX30) < 0200 OR AsNumeric(^EPMTSYSTX30) > 9998))
    
            Data Elements:
    
            RP.AddressDetails.Business:^EPMTSYSTX30 = pyde.02.00:AddressDetails.Postcode.Text
    
            RP.AddressDetails.Business:^EPMTSYSTX44 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX44 == false && (AsNumeric(report.EPMTSYSTX30) < 200 || AsNumeric(report.EPMTSYSTX30) > 9998));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000127",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"A valid postcode must be supplied",
                    LongDescription = @"When the address is within Australia, the Postcode must be in the range of '0200-9998'.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:AddressDetailsBusiness/tns:PostcodeText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000030" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX44", Value = GetValueOrEmpty(report.EPMTSYSTX44) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX30", Value = report.EPMTSYSTX30 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000030

            #region VR.ATO.EPMTSYSTX.000031

            /*  VR.ATO.EPMTSYSTX.000031
            When the address is overseas, the Postcode must be blank.
    
            Legacy Rule Format:
            (^EPMTSYSTX44 = TRUE AND ^EPMTSYSTX30 <> NULL)

            Technical Business Rule Format:
            ^EPMTSYSTX44 = TRUE AND ^EPMTSYSTX30 <> NULL
    
            Data Elements:
    
            RP.AddressDetails.Business:^EPMTSYSTX30 = pyde.02.00:AddressDetails.Postcode.Text
    
            RP.AddressDetails.Business:^EPMTSYSTX44 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX44 == true && report.EPMTSYSTX30 != null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000128",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Postcode must be left blank",
                    LongDescription = @"When the address is overseas, the Postcode must be blank.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:AddressDetailsBusiness/tns:PostcodeText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000031" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX44", Value = GetValueOrEmpty(report.EPMTSYSTX44) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX30", Value = report.EPMTSYSTX30 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000031

            #region VR.ATO.EPMTSYSTX.000033

            /*  VR.ATO.EPMTSYSTX.000033
            When the address is within Australia, the State / Territory must be a valid state code.
    
            Legacy Rule Format:
            (^EPMTSYSTX44 = FALSE AND NotInSet(^EPMTSYSTX29,'"ACT","NSW","NT","QLD","SA","TAS","VIC","WA"'))

            Technical Business Rule Format:
            (^EPMTSYSTX44 = FALSE AND NotInSet(^EPMTSYSTX29,'"ACT","NSW","NT","QLD","SA","TAS","VIC","WA"'))
    
            Data Elements:
    
            RP.AddressDetails.Business:^EPMTSYSTX29 = pyde.02.00:AddressDetails.StateOrTerritory.Code
    
            RP.AddressDetails.Business:^EPMTSYSTX44 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX44 == false && !(IsMatch(report.EPMTSYSTX29, @"^(ACT|NSW|NT|QLD|SA|TAS|VIC|WA)$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000125",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"A valid state or territory code must be supplied",
                    LongDescription = @"When the address is within Australia, the State / Territory must be a valid state code.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:AddressDetailsBusiness/tns:StateOrTerritoryCode",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000033" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX44", Value = GetValueOrEmpty(report.EPMTSYSTX44) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX29", Value = report.EPMTSYSTX29 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000033

            #region VR.ATO.EPMTSYSTX.000035

            /*  VR.ATO.EPMTSYSTX.000035
            When the address is overseas, the Country Name cannot be 'AUSTRALIA' or blank.
    
            Legacy Rule Format:
            (^EPMTSYSTX44 = TRUE AND (^EPMTSYSTX32 = NULLORBLANK OR RegexMatch(^EPMTSYSTX32,  '^\s*AUSTRALIA\s*$', 'i')))

            Technical Business Rule Format:
            (^EPMTSYSTX44 = TRUE AND (^EPMTSYSTX32 = BLANK OR RegexMatch(^EPMTSYSTX32,  '^\s*AUSTRALIA\s*$', 'i')))
    
            Data Elements:
    
            RP.AddressDetails.Business:^EPMTSYSTX32 = pyde.02.08:AddressDetails.CountryName.Text
    
            RP.AddressDetails.Business:^EPMTSYSTX44 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX44 == true && (string.IsNullOrWhiteSpace(report.EPMTSYSTX32) == true || RegexMatch(report.EPMTSYSTX32, @"^\s*AUSTRALIA\s*$", @"i")));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000130",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"A country other than Australia must be entered",
                    LongDescription = @"When the address is overseas, the Country Name cannot be 'AUSTRALIA' or blank.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:AddressDetailsBusiness/tns:CountryNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000035" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX44", Value = GetValueOrEmpty(report.EPMTSYSTX44) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX32", Value = report.EPMTSYSTX32 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000035

            #region VR.ATO.EPMTSYSTX.000036

            /*  VR.ATO.EPMTSYSTX.000036
            Reporting party postal street address line one must be present.
    
            Legacy Rule Format:
            (^EPMTSYSTX33 = BLANK)

            Technical Business Rule Format:
            ^EPMTSYSTX33 = BLANK
    
            Data Elements:
    
            RP.AddressDetails.Postal:^EPMTSYSTX33 = pyde.02.00:AddressDetails.Line1.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTX33) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must be present",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:AddressDetailsPostal/tns:Line1Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000036" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX33", Value = report.EPMTSYSTX33 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000036

            #region VR.ATO.EPMTSYSTX.000039

            /*  VR.ATO.EPMTSYSTX.000039
            Reporting party postal address suburb, town or locality must be present.
    
            Legacy Rule Format:
            (^EPMTSYSTX35 = BLANK)

            Technical Business Rule Format:
            ^EPMTSYSTX35 = BLANK
    
            Data Elements:
    
            RP.AddressDetails.Postal:^EPMTSYSTX35 = pyde.02.00:AddressDetails.LocalityName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTX35) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must be present",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:AddressDetailsPostal/tns:LocalityNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000039" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX35", Value = report.EPMTSYSTX35 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000039

            #region VR.ATO.EPMTSYSTX.000040

            /*  VR.ATO.EPMTSYSTX.000040
            When the address is within Australia, the Postcode must be in the range of '0200-9998'.
    
            Legacy Rule Format:
            (^EPMTSYSTX43 = FALSE AND (AsNumeric(^EPMTSYSTX37) < 0200 OR AsNumeric(^EPMTSYSTX37) > 9998))

            Technical Business Rule Format:
            (^EPMTSYSTX43 = FALSE AND (AsNumeric(^EPMTSYSTX37) < 0200 OR AsNumeric(^EPMTSYSTX37) > 9998))
    
            Data Elements:
    
            RP.AddressDetails.Postal:^EPMTSYSTX37 = pyde.02.00:AddressDetails.Postcode.Text
    
            RP.AddressDetails.Postal:^EPMTSYSTX43 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX43 == false && (AsNumeric(report.EPMTSYSTX37) < 200 || AsNumeric(report.EPMTSYSTX37) > 9998));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000127",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"A valid postcode must be supplied",
                    LongDescription = @"When the address is within Australia, the Postcode must be in the range of '0200-9998'.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:AddressDetailsPostal/tns:PostcodeText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000040" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX43", Value = GetValueOrEmpty(report.EPMTSYSTX43) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX37", Value = report.EPMTSYSTX37 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000040

            #region VR.ATO.EPMTSYSTX.000041

            /*  VR.ATO.EPMTSYSTX.000041
            When the address is overseas, the Postcode must be blank.
    
            Legacy Rule Format:
            (^EPMTSYSTX43 = TRUE AND ^EPMTSYSTX37 <> NULL)

            Technical Business Rule Format:
            ^EPMTSYSTX43 = TRUE AND ^EPMTSYSTX37 <> NULL
    
            Data Elements:
    
            RP.AddressDetails.Postal:^EPMTSYSTX37 = pyde.02.00:AddressDetails.Postcode.Text
    
            RP.AddressDetails.Postal:^EPMTSYSTX43 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX43 == true && report.EPMTSYSTX37 != null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000128",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Postcode must be left blank",
                    LongDescription = @"When the address is overseas, the Postcode must be blank.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:AddressDetailsPostal/tns:PostcodeText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000041" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX43", Value = GetValueOrEmpty(report.EPMTSYSTX43) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX37", Value = report.EPMTSYSTX37 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000041

            #region VR.ATO.EPMTSYSTX.000042

            /*  VR.ATO.EPMTSYSTX.000042
            When the address is within Australia, the State / Territory must be a valid state code.
    
            Legacy Rule Format:
            (^EPMTSYSTX43 = FALSE AND NotInSet(^EPMTSYSTX36,'"ACT","NSW","NT","QLD","SA","TAS","VIC","WA"'))

            Technical Business Rule Format:
            (^EPMTSYSTX43 = FALSE AND NotInSet(^EPMTSYSTX36,'"ACT","NSW","NT","QLD","SA","TAS","VIC","WA"'))
    
            Data Elements:
    
            RP.AddressDetails.Postal:^EPMTSYSTX36 = pyde.02.00:AddressDetails.StateOrTerritory.Code
    
            RP.AddressDetails.Postal:^EPMTSYSTX43 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX43 == false && !(IsMatch(report.EPMTSYSTX36, @"^(ACT|NSW|NT|QLD|SA|TAS|VIC|WA)$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000125",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"A valid state or territory code must be supplied",
                    LongDescription = @"When the address is within Australia, the State / Territory must be a valid state code.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:AddressDetailsPostal/tns:StateOrTerritoryCode",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000042" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX43", Value = GetValueOrEmpty(report.EPMTSYSTX43) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX36", Value = report.EPMTSYSTX36 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000042

            #region VR.ATO.EPMTSYSTX.000043

            /*  VR.ATO.EPMTSYSTX.000043
            When the address is overseas, the Country Name cannot be 'AUSTRALIA' or blank.
    
            Legacy Rule Format:
            (^EPMTSYSTX43 = TRUE AND (^EPMTSYSTX39 = NULLORBLANK OR RegexMatch(^EPMTSYSTX39, '^\s*AUSTRALIA\s*$', 'i')))

            Technical Business Rule Format:
            (^EPMTSYSTX43 = TRUE AND (^EPMTSYSTX39 = BLANK OR RegexMatch(^EPMTSYSTX39, '^\s*AUSTRALIA\s*$', 'i')))
    
            Data Elements:
    
            RP.AddressDetails.Postal:^EPMTSYSTX39 = pyde.02.08:AddressDetails.CountryName.Text
    
            RP.AddressDetails.Postal:^EPMTSYSTX43 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX43 == true && (string.IsNullOrWhiteSpace(report.EPMTSYSTX39) == true || RegexMatch(report.EPMTSYSTX39, @"^\s*AUSTRALIA\s*$", @"i")));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000130",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"A country other than Australia must be entered",
                    LongDescription = @"When the address is overseas, the Country Name cannot be 'AUSTRALIA' or blank.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:AddressDetailsPostal/tns:CountryNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000043" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX43", Value = GetValueOrEmpty(report.EPMTSYSTX43) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX39", Value = report.EPMTSYSTX39 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000043

            #region VR.ATO.EPMTSYSTX.000044

            /*  VR.ATO.EPMTSYSTX.000044
            The Intermediary file reference number must be present.
    
            Legacy Rule Format:
            (^EPMTSYSTX2 = BLANK)

            Technical Business Rule Format:
            ^EPMTSYSTX2 = BLANK
    
            Data Elements:
    
            INT:^EPMTSYSTX2 = pyid.02.00:IdentificationDetails.IdentifierDesignation.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTX2) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must be present",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:INT/tns:IdentificationDetailsIdentifierDesignationText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000044" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX2", Value = report.EPMTSYSTX2 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000044

            #region VR.ATO.EPMTSYSTX.000045

            /*  VR.ATO.EPMTSYSTX.000045
            The intermediary name must be present.
    
            Legacy Rule Format:
            (^EPMTSYSTX3 = BLANK)

            Technical Business Rule Format:
            ^EPMTSYSTX3 = BLANK
    
            Data Elements:
    
            INT:^EPMTSYSTX3 = pyde.02.00:OrganisationNameDetails.OrganisationalName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTX3) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must be present",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:INT/tns:OrganisationNameDetailsOrganisationalNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000045" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX3", Value = report.EPMTSYSTX3 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000045

            #region VR.ATO.EPMTSYSTX.000046

            /*  VR.ATO.EPMTSYSTX.000046
            The intermediary contact name must be present.
    
            Legacy Rule Format:
            (^EPMTSYSTX4 = BLANK)

            Technical Business Rule Format:
            ^EPMTSYSTX4 = BLANK
    
            Data Elements:
    
            INT.PrimaryContact:^EPMTSYSTX4 = pyde.02.00:PersonUnstructuredName.FullName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTX4) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must be present",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:INT/tns:PrimaryContact/tns:PersonUnstructuredNameFullNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000046" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX4", Value = report.EPMTSYSTX4 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000046

            #region VR.ATO.EPMTSYSTX.000047

            /*  VR.ATO.EPMTSYSTX.000047
            The intermediary contact email address must be a valid email.
    
            Legacy Rule Format:
            (NOT IsValidEmail(^EPMTSYSTX7))

            Technical Business Rule Format:
            (NOT IsValidEmail(^EPMTSYSTX7))
    
            Data Elements:
    
            INT.PrimaryContact:^EPMTSYSTX7 = pyde.02.00:ElectronicContact.ElectronicMail.Address.Text
            */
            assertion = !(IsMatch(report.EPMTSYSTX7, @"^\S.*@.+\.\S+$"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000102",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid email",
                    LongDescription = @"The local part of an email address (before the @)  generally consists of letters and digits and may also include some special characters. The domain part  (after the @) generally consists of letters, digits, hyphens and dots only. A domain part must include a dot, but must not start or end with a dot.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:INT/tns:PrimaryContact/tns:ElectronicContactElectronicMailAddressText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000047" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX7", Value = report.EPMTSYSTX7 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000047

            #region VR.ATO.EPMTSYSTX.000048

            /*  VR.ATO.EPMTSYSTX.000048
            When the address is within Australia, the Country Name must be 'AUSTRALIA' or not be present.
    
            Legacy Rule Format:
            (^EPMTSYSTX42 = FALSE AND (^EPMTSYSTX14 <> NULLORBLANK AND NOT RegexMatch(^EPMTSYSTX14, '^\s*AUSTRALIA\s*$', 'i')))

            Technical Business Rule Format:
            (^EPMTSYSTX42 = FALSE AND (^EPMTSYSTX14 <> BLANK AND NOT RegexMatch(^EPMTSYSTX14, '^\s*AUSTRALIA\s*$', 'i')))
    
            Data Elements:
    
            INT.AddressDetails.Business:^EPMTSYSTX14 = pyde.02.08:AddressDetails.CountryName.Text
    
            INT.AddressDetails.Business:^EPMTSYSTX42 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX42 == false && (string.IsNullOrWhiteSpace(report.EPMTSYSTX14) != true && !(RegexMatch(report.EPMTSYSTX14, @"^\s*AUSTRALIA\s*$", @"i"))));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000129",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Country Name must be 'AUSTRALIA' or not be present",
                    LongDescription = @"When the address is within Australia, the Country Name must be 'AUSTRALIA' or blank.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:INT/tns:AddressDetailsBusiness/tns:CountryNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000048" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX42", Value = GetValueOrEmpty(report.EPMTSYSTX42) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX14", Value = report.EPMTSYSTX14 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000048

            #region VR.ATO.EPMTSYSTX.000049

            /*  VR.ATO.EPMTSYSTX.000049
            Reporting party contact email address must be a valid email.
    
            Legacy Rule Format:
            (NOT IsValidEmail(^EPMTSYSTX25))

            Technical Business Rule Format:
            (NOT IsValidEmail(^EPMTSYSTX25))
    
            Data Elements:
    
            RP.PrimaryContact:^EPMTSYSTX25 = pyde.02.00:ElectronicContact.ElectronicMail.Address.Text
            */
            assertion = !(IsMatch(report.EPMTSYSTX25, @"^\S.*@.+\.\S+$"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000102",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid email",
                    LongDescription = @"The local part of an email address (before the @)  generally consists of letters and digits and may also include some special characters. The domain part  (after the @) generally consists of letters, digits, hyphens and dots only. A domain part must include a dot, but must not start or end with a dot.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:PrimaryContact/tns:ElectronicContactElectronicMailAddressText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000049" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX25", Value = report.EPMTSYSTX25 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000049

            #region VR.ATO.EPMTSYSTX.000050

            /*  VR.ATO.EPMTSYSTX.000050
            Reporting party registered name must be present.
    
            Legacy Rule Format:
            (^EPMTSYSTX17 = BLANK)

            Technical Business Rule Format:
            ^EPMTSYSTX17 = BLANK
    
            Data Elements:
    
            RP.MN:^EPMTSYSTX17 = pyde.02.00:OrganisationNameDetails.OrganisationalName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTX17) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must be present",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:MN/tns:OrganisationNameDetailsOrganisationalNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000050" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX17", Value = report.EPMTSYSTX17 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000050

            #region VR.ATO.EPMTSYSTX.000051

            /*  VR.ATO.EPMTSYSTX.000051
            The date reported in the Reporting Period Start Date must not be before 01/07/2017.
    
            Legacy Rule Format:
            ^EPMTSYSTX40 < ConvertToDate(1, 7, 2017)

            Technical Business Rule Format:
            ^EPMTSYSTX40 < ConvertToDate(1, 7, 2017)
    
            Data Elements:
    
            RP:^EPMTSYSTX40 = pyin.02.00:Period.Start.Date
            */
            assertion = (report.EPMTSYSTX40.GetValueOrDefault() < ConvertToDate(1, 7, 2017));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000105",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The start date can not be before 01/07/2017",
                    LongDescription = @"The date reported in the Reporting Period Start Date must not be before 01/07/2017.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:PeriodStartDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000051" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX40", Value = GetValueOrEmpty(report.EPMTSYSTX40) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000051

            #region VR.ATO.EPMTSYSTX.000052

            /*  VR.ATO.EPMTSYSTX.000052
            Reporting party contact name must be present.
    
            Legacy Rule Format:
            (^EPMTSYSTX20 = BLANK)

            Technical Business Rule Format:
            ^EPMTSYSTX20 = BLANK
    
            Data Elements:
    
            RP.PrimaryContact:^EPMTSYSTX20 = pyde.02.00:PersonUnstructuredName.FullName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTX20) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must be present",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:PrimaryContact/tns:PersonUnstructuredNameFullNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000052" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX20", Value = report.EPMTSYSTX20 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000052

            #region VR.ATO.EPMTSYSTX.000053

            /*  VR.ATO.EPMTSYSTX.000053
            Reporting party contact phone number must be present.
    
            Legacy Rule Format:
            (^EPMTSYSTX22 = BLANK)

            Technical Business Rule Format:
            ^EPMTSYSTX22 = BLANK
    
            Data Elements:
    
            RP.PrimaryContact:^EPMTSYSTX22 = pyde.02.00:ElectronicContact.Telephone.Minimal.Number
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTX22) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must be present",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:PrimaryContact/tns:ElectronicContactTelephoneMinimalNumber",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000053" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX22", Value = report.EPMTSYSTX22 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000053

            #region VR.ATO.EPMTSYSTX.000054

            /*  VR.ATO.EPMTSYSTX.000054
            When the address is within Australia, the Country Name must be 'AUSTRALIA' or blank.
    
            Legacy Rule Format:
            (^EPMTSYSTX44 = FALSE AND (^EPMTSYSTX32 <> NULLORBLANK AND NOT RegexMatch(^EPMTSYSTX32, '^\s*AUSTRALIA\s*$', 'i')))

            Technical Business Rule Format:
            (^EPMTSYSTX44 = FALSE AND (^EPMTSYSTX32 <> BLANK AND NOT RegexMatch(^EPMTSYSTX32, '^\s*AUSTRALIA\s*$', 'i')))
    
            Data Elements:
    
            RP.AddressDetails.Business:^EPMTSYSTX32 = pyde.02.08:AddressDetails.CountryName.Text
    
            RP.AddressDetails.Business:^EPMTSYSTX44 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX44 == false && (string.IsNullOrWhiteSpace(report.EPMTSYSTX32) != true && !(RegexMatch(report.EPMTSYSTX32, @"^\s*AUSTRALIA\s*$", @"i"))));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000129",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Country Name must be 'AUSTRALIA' or not be present",
                    LongDescription = @"When the address is within Australia, the Country Name must be 'AUSTRALIA' or blank.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:AddressDetailsBusiness/tns:CountryNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000054" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX44", Value = GetValueOrEmpty(report.EPMTSYSTX44) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX32", Value = report.EPMTSYSTX32 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000054

            #region VR.ATO.EPMTSYSTX.000055

            /*  VR.ATO.EPMTSYSTX.000055
            When the address is within Australia, the Country Name must be 'AUSTRALIA' or blank.
    
            Legacy Rule Format:
            (^EPMTSYSTX43 = FALSE AND (^EPMTSYSTX39 <> NULLORBLANK AND NOT RegexMatch(^EPMTSYSTX39, '^\s*AUSTRALIA\s*$', 'i')))

            Technical Business Rule Format:
            (^EPMTSYSTX43 = FALSE AND (^EPMTSYSTX39 <> BLANK AND NOT RegexMatch(^EPMTSYSTX39, '^\s*AUSTRALIA\s*$', 'i')))
    
            Data Elements:
    
            RP.AddressDetails.Postal:^EPMTSYSTX39 = pyde.02.08:AddressDetails.CountryName.Text
    
            RP.AddressDetails.Postal:^EPMTSYSTX43 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX43 == false && (string.IsNullOrWhiteSpace(report.EPMTSYSTX39) != true && !(RegexMatch(report.EPMTSYSTX39, @"^\s*AUSTRALIA\s*$", @"i"))));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000129",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Country Name must be 'AUSTRALIA' or not be present",
                    LongDescription = @"When the address is within Australia, the Country Name must be 'AUSTRALIA' or blank.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:AddressDetailsPostal/tns:CountryNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000055" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX43", Value = GetValueOrEmpty(report.EPMTSYSTX43) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX39", Value = report.EPMTSYSTX39 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000055

            #region VR.ATO.EPMTSYSTX.000056

            /*  VR.ATO.EPMTSYSTX.000056
            Intermediary phone number must be provided
    
            Legacy Rule Format:
            (^EPMTSYSTX6 = BLANK)

            Technical Business Rule Format:
            ^EPMTSYSTX6 = BLANK
    
            Data Elements:
    
            INT.PrimaryContact:^EPMTSYSTX6 = pyde.02.00:ElectronicContact.Telephone.Minimal.Number
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTX6) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must be present",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:INT/tns:PrimaryContact/tns:ElectronicContactTelephoneMinimalNumber",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000056" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX6", Value = report.EPMTSYSTX6 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000056

            #region VR.ATO.EPMTSYSTX.000057

            /*  VR.ATO.EPMTSYSTX.000057
            When the address is overseas, the State / Territory must be blank.
    
            Legacy Rule Format:
            (^EPMTSYSTX42 = TRUE AND ^EPMTSYSTX11 <> NULL)

            Technical Business Rule Format:
            ^EPMTSYSTX42 = TRUE AND ^EPMTSYSTX11 <> NULL
    
            Data Elements:
    
            INT.AddressDetails.Business:^EPMTSYSTX11 = pyde.02.00:AddressDetails.StateOrTerritory.Code
    
            INT.AddressDetails.Business:^EPMTSYSTX42 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX42 == true && report.EPMTSYSTX11 != null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000126",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must be left blank",
                    LongDescription = @"When the address is overseas, the State / Territory must be blank.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:INT/tns:AddressDetailsBusiness/tns:StateOrTerritoryCode",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000057" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX42", Value = GetValueOrEmpty(report.EPMTSYSTX42) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX11", Value = report.EPMTSYSTX11 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000057

            #region VR.ATO.EPMTSYSTX.000058

            /*  VR.ATO.EPMTSYSTX.000058
            When the address is overseas, the State / Territory must be blank.
    
            Legacy Rule Format:
            (^EPMTSYSTX44 = TRUE AND ^EPMTSYSTX29 <> NULL)

            Technical Business Rule Format:
            ^EPMTSYSTX44 = TRUE AND ^EPMTSYSTX29 <> NULL
    
            Data Elements:
    
            RP.AddressDetails.Business:^EPMTSYSTX29 = pyde.02.00:AddressDetails.StateOrTerritory.Code
    
            RP.AddressDetails.Business:^EPMTSYSTX44 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX44 == true && report.EPMTSYSTX29 != null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000126",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must be left blank",
                    LongDescription = @"When the address is overseas, the State / Territory must be blank.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:AddressDetailsBusiness/tns:StateOrTerritoryCode",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000058" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX44", Value = GetValueOrEmpty(report.EPMTSYSTX44) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX29", Value = report.EPMTSYSTX29 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000058

            #region VR.ATO.EPMTSYSTX.000059

            /*  VR.ATO.EPMTSYSTX.000059
            When the address is overseas, the State / Territory must be blank.
    
            Legacy Rule Format:
            (^EPMTSYSTX43 = TRUE AND ^EPMTSYSTX36 <> NULL)

            Technical Business Rule Format:
            ^EPMTSYSTX43 = TRUE AND ^EPMTSYSTX36 <> NULL
    
            Data Elements:
    
            RP.AddressDetails.Postal:^EPMTSYSTX36 = pyde.02.00:AddressDetails.StateOrTerritory.Code
    
            RP.AddressDetails.Postal:^EPMTSYSTX43 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTX43 == true && report.EPMTSYSTX36 != null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000126",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must be left blank",
                    LongDescription = @"When the address is overseas, the State / Territory must be blank.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:AddressDetailsPostal/tns:StateOrTerritoryCode",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000059" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX43", Value = GetValueOrEmpty(report.EPMTSYSTX43) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX36", Value = report.EPMTSYSTX36 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000059

            #region VR.ATO.EPMTSYSTX.000060

            /*  VR.ATO.EPMTSYSTX.000060
            Must be less than or equal to the date reported in the Date Timestamp Report Created field.
    
            Legacy Rule Format:
            ^EPMTSYSTX40 > ^EPMTSYSTX45

            Technical Business Rule Format:
            ^EPMTSYSTX40 > ^EPMTSYSTX45
    
            Data Elements:
    
            RP:^EPMTSYSTX40 = pyin.02.00:Period.Start.Date
    
            INT:^EPMTSYSTX45 = pyin.02.00:BusinessDocument.Creation.Datetime
            */
            assertion = (report.EPMTSYSTX40.GetValueOrDefault() > report.EPMTSYSTX45.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000133",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This date must be earlier than present",
                    LongDescription = @"The date reported in the Reporting Period Start Date must be less than or equal to the date reported in the Date Timestamp Report Created field.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:PeriodStartDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000060" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX40", Value = GetValueOrEmpty(report.EPMTSYSTX40) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX45", Value = GetValueOrEmpty(report.EPMTSYSTX45) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000060

            #region VR.ATO.EPMTSYSTX.000061

            /*  VR.ATO.EPMTSYSTX.000061
            Reporting period start date must be within the current financial year.
    
            Legacy Rule Format:
            (FinancialYear(^EPMTSYSTX40) <> FinancialYear(^EPMTSYSTX41))

            Technical Business Rule Format:
            (FinancialYear(^EPMTSYSTX40) <> FinancialYear(^EPMTSYSTX41))
    
            Data Elements:
    
            RP:^EPMTSYSTX40 = pyin.02.00:Period.Start.Date
    
            RP:^EPMTSYSTX41 = pyin.02.00:Period.End.Date
            */
            assertion = (FinancialYear(report.EPMTSYSTX40.GetValueOrDefault()) != FinancialYear(report.EPMTSYSTX41.GetValueOrDefault()));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000136",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The date must be within the same financial year",
                    LongDescription = @"The Reporting Period Start and End date must be in the same financial year.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:PeriodStartDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000061" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX40", Value = GetValueOrEmpty(report.EPMTSYSTX40) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX41", Value = GetValueOrEmpty(report.EPMTSYSTX41) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000061

            #region VR.ATO.EPMTSYSTX.000063

            /*  VR.ATO.EPMTSYSTX.000063
            Reporting party branch number must not be less than 001.
    
            Legacy Rule Format:
            (AsNumeric(^EPMTSYSTX19) < 1)

            Technical Business Rule Format:
            (AsNumeric(^EPMTSYSTX19) < 1)
    
            Data Elements:
    
            RP:^EPMTSYSTX19 = pyid.02.16:FinancialInstitutionAccount.Branch.Number
            */
            assertion = (AsNumeric(report.EPMTSYSTX19) < 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000135",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The value must be greater than 0",
                    LongDescription = @"Branch number must be greater than 0.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:FinancialInstitutionAccountBranchNumber",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000063" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX19", Value = report.EPMTSYSTX19 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000063

            #region VR.ATO.EPMTSYSTX.000064

            /*  VR.ATO.EPMTSYSTX.000064
            Reporting party business street address line 1 must be present.
    
            Legacy Rule Format:
            (^EPMTSYSTX26 = BLANK)

            Technical Business Rule Format:
            ^EPMTSYSTX26 = BLANK
    
            Data Elements:
    
            RP.AddressDetails.Business:^EPMTSYSTX26 = pyde.02.00:AddressDetails.Line1.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTX26) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must be present",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXREQUEST/tns:RP/tns:AddressDetailsBusiness/tns:Line1Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000064" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTX26", Value = report.EPMTSYSTX26 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000064

            foreach (ProcessMessageDocument currentProcessMessage in response)
            {
                if (currentProcessMessage.Parameters != null)
                {
                    foreach (ProcessMessageParameter currentParameter in currentProcessMessage.Parameters)
                    {
                        if (string.IsNullOrEmpty(currentParameter.Name))
                        {
                            currentParameter.Name = _emptyParameterValue;
                        }

                        if (currentParameter.Name.Length > _maxParameterNameLength)
                        {
                            currentParameter.Name = currentParameter.Name.Substring(0, _maxParameterNameLength - 1);
                        }

                        if (string.IsNullOrEmpty(currentParameter.Value))
                        {
                            currentParameter.Value = _emptyParameterValue;
                        }

                        if (currentParameter.Value.Length > _maxParameterValueLength)
                        {
                            currentParameter.Value = currentParameter.Value.Substring(0, _maxParameterValueLength - 1);
                        }
                    }
                }
            }
            this.MaximumSeverity = maxSeverity;
            return response;
        }

        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        public List<ProcessMessageDocument> ValidateCrossformReport(EPMTSYSTX201702ValidatorPersistParent report, EPMTSYSTXCLNTREQUEST2017 childReport, bool isXbrl = true, string DocumentPartIdentifier = "")
        {

            List<ProcessMessageDocument> response = new List<ProcessMessageDocument>();
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            bool assertion;

            //this.ConsumedReport = report;
            this.ConsumedChildReport = childReport;

            ProcessMessageSeverity maxSeverity = ProcessMessageSeverity.Progressive;

            // ------------------------------------------------------------------------------
            // Validations can now be done in code rather than just schematron.
            // This version supports full validation of a report - for those rules that have successfully parsed and could be generated.
            // Generated Validations include:
            //   - Validation logic in C# rather than being Schematron based.
            //   - Production of errors in EBMS, SBR and SWS format.
            // 
            // The generation at this stage does not support the following - and has to be completed manually (later versions of the generation will do this for you)
            //   - Business Rules that did not parse.  The ESR team will help support you where this happens as an effort is being made to rectify these
            //   - You will get TODO tasks for those that the parser could not cope with
            // ------------------------------------------------------------------------------

            #region Cross Form Rules

            #region VR.ATO.EPMTSYSTX.000001

            /*  VR.ATO.EPMTSYSTX.000001
                            At least one EPMTSYSTXCLNT child must be provided.
            
                            Legacy Rule Format:
                            Count(^EPMTSYSTXCLNT) = 0
                
                            Parseable Rule Format:
                            Count(^EPMTSYSTXCLNT) = 0
                    
                            Data Elements:
                    
                            ^EPMTSYSTXCLNT = EPMTSYSTXCLNT
                            */
            //VRATOEPMTSYSTX000001(response, report, isXbrl);
            assertion = (childReport == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTX.000001",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"At least one EPMTSYSTXCLNT child must be provided",
                    Location = isXbrl ? "/xbrli:xbrl/pyid.02.15:FinancialInstitutionAccount.Branch.Number" : null,
                    Parameters = new ProcessMessageParameters()
                    { new ProcessMessageParameter()
                    { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000001" } },
                };
                if (maxSeverity > processMessage.Severity)
                {
                    maxSeverity = processMessage.Severity;
                }

                processMessage.DocumentSequence = DocumentPartIdentifier;

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCONTEXT", Value = "EPMTSYSTXCONTEXT" });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTX.000001

            #region VR.ATO.EPMTSYSTX.000018

            /*  VR.ATO.EPMTSYSTX.000018
                    The Transaction Period Start Date is earlier than the reporting period start date.

                    Legacy Rule Format:
                    ^EPMTSYSTXCLNT33 < ^EPMTSYSTX40

                    Parseable Rule Format:
                    ^EPMTSYSTXCLNT33 < ^EPMTSYSTX40

                    Data Elements:
    
                    RP:^EPMTSYSTX40 = pyin.02.00:Period.Start.Date
    
                    RP:^EPMTSYSTXCLNT33 = EPMTSYSTXCLNT33
                    */

            if (childReport != null)
            {
                int itemIndex1 = 0;
                foreach (EPMTSYSTXCLNTREQUEST2017.BusinessReportingPeriod brp in childReport.BusinessReportingPeriodCollection)
                {
                    itemIndex1++;

                    //assertion = (DateTime.Parse(brp.EPMTSYSTXCLNT33.ToString()) < DateTime.Parse(report.EPMTSYSTX40.ToString()));
                    assertion = (brp.EPMTSYSTXCLNT33 < report.EPMTSYSTX40);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.EPMTSYSTX.000018",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Transaction period start date is invalid",
                            LongDescription = @"The date reported in the Transaction Period Start Date must be on or after the date reported in the Reporting Period Start Date field.",
                            Location = isXbrl ? "/xbrli:xbrl/pyin.02.00:Period.Start.Date" : "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:BusinessReportingPeriodCollection/tns:BusinessReportingPeriod[" + itemIndex1 + "]/tns:PeriodStartDate",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter()
                            { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000018" } },
                        };
                        if (maxSeverity > processMessage.Severity)
                        {
                            maxSeverity = processMessage.Severity;
                        }

                        processMessage.DocumentSequence = DocumentPartIdentifier;

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "EPMTSYSTX40", Value = report.EPMTSYSTX40.GetValueOrEmpty() });
                        response.Add(processMessage);

                    }
                }
            }



            #endregion // VR.ATO.EPMTSYSTX.000018

            #region VR.ATO.EPMTSYSTX.000020

            /*  VR.ATO.EPMTSYSTX.000020
            The transaction period end date is later than the reporting period end date.

            Legacy Rule Format:
            ^EPMTSYSTXCLNT34 > ^EPMTSYSTX41

            Parseable Rule Format:
            ^EPMTSYSTXCLNT34 > ^EPMTSYSTX41

            Data Elements:
    
            RP:^EPMTSYSTX41 = pyin.02.00:Period.End.Date
    
            RP:^EPMTSYSTXCLNT34 = EPMTSYSTXCLNT34
            */
            //VRATOEPMTSYSTX000020(response, report, isXbrl);
            if (childReport != null)
            {
                int itemIndex1 = 0;
                foreach (EPMTSYSTXCLNTREQUEST2017.BusinessReportingPeriod brp3 in childReport.BusinessReportingPeriodCollection)
                {
                    itemIndex1++;

                    assertion = (brp3.EPMTSYSTXCLNT34 > report.EPMTSYSTX41);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.EPMTSYSTX.000020",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Transaction period end date is invalid",
                            LongDescription = @"The date reported in the Transaction Period End Date must be on or before the date reported in the Reporting Period End Date field.",
                            Location = isXbrl ? "/xbrli:xbrl/pyin.02.00:Period.Start.Date" : "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:BusinessReportingPeriodCollection/tns:BusinessReportingPeriod[" + itemIndex1 + "]/tns:PeriodEndDate",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTX.000020" } },
                        };
                        if (maxSeverity > processMessage.Severity)
                        {
                            maxSeverity = processMessage.Severity;
                        }

                        processMessage.DocumentSequence = DocumentPartIdentifier;

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "EPMTSYSTX41", Value = report.EPMTSYSTX40.GetValueOrEmpty() });

                        response.Add(processMessage);
                    }

                }
            }




            #endregion // VR.ATO.EPMTSYSTX.000020

            foreach (ProcessMessageDocument currentProcessMessage in response)
            {
                if (currentProcessMessage.Parameters != null)
                {
                    foreach (ProcessMessageParameter currentParameter in currentProcessMessage.Parameters)
                    {
                        if (string.IsNullOrEmpty(currentParameter.Name))
                        {
                            currentParameter.Name = _emptyParameterValue;
                        }

                        if (currentParameter.Name.Length > _maxParameterNameLength)
                        {
                            currentParameter.Name = currentParameter.Name.Substring(0, _maxParameterNameLength - 1);
                        }

                        if (string.IsNullOrEmpty(currentParameter.Value))
                        {
                            currentParameter.Value = _emptyParameterValue;
                        }

                        if (currentParameter.Value.Length > _maxParameterValueLength)
                        {
                            currentParameter.Value = currentParameter.Value.Substring(0, _maxParameterValueLength - 1);
                        }
                    }
                }
            }
            if (this.MaximumSeverityCrossForm > maxSeverity)
            {
                this.MaximumSeverityCrossForm = maxSeverity;
            }
            return response;
        }


        #region GetProcessMessage
        private static ProcessMessageDocument GetProcessMessage(string diagnosticId, string location = null, List<ProcessMessageParameter> parameters = null)
        {
            ProcessMessageDocument response;

            response = CloneMessage(_processMessageDocuments[diagnosticId]);
            if (location != null)
            {
                response.Location = location;
            }

            if (parameters != null)
            {
                response.Parameters.AddRange(parameters);
            }

            return response;
        }
        #endregion // GetProcessMessage

        #endregion

        #endregion

    }
}
