// ------------------------------------------------------------------------------
//  <auto-generated>
//     This code was generated from a template.
// 
//     Manual changes to this file will be overwritten if the code is regenerated.
//
//     Generated on 2017-07-07T15:02:28, by ESR Version 1.65.0.0 using ESR Database 
//  </auto-generated>
// ------------------------------------------------------------------------------

using System;
using System.IO;
using System.Runtime.CompilerServices;
using System.Text;
using System.Xml;
using System.Linq;
using System.Collections.Generic;
using System.Text.RegularExpressions;

using DataContracts;

namespace Ato.EN.IntegrationServices.CodeGenerationEPMTSYSTXCLNT
{

    public partial class EPMTSYSTXCLNTREQUEST2017Validator
    {
        /// <summary>
        /// The max parameter name length is restricted by the SBR1 and SBR2 schemas - the lowest common denominator of SBR 1 is used as the default
        /// </summary>
        private int _maxParameterNameLength;

        /// <summary>
        /// The max parameter value length is restricted by the SBR1 and SBR2 schemas
        /// </summary>
        private int _maxParameterValueLength;

        /// <summary>
        /// The SBR1 and ebms3 schemas do not allow parameter names or values to be the empty string
        /// </summary>
        private string _emptyParameterValue;

        /// <summary>
        /// Initializes a new instance of the <see cref="EPMTSYSTXCLNTREQUEST2017Validator" /> class.
        /// </summary>
        /// <param name="maxParameterNameLength">Maximum length of the parameter name.</param>
        /// <param name="maxParameterValueLength">Maximum length of the parameter value.</param>
        /// <param name="emptyParameterValue">This value will be used in place of any parameter values that result in a null or empty value.</param>
        public EPMTSYSTXCLNTREQUEST2017Validator(int maxParameterNameLength = 20, int maxParameterValueLength = 4096, string emptyParameterValue = "EMPTY")
        {
            _maxParameterNameLength = maxParameterNameLength;
            _maxParameterValueLength = maxParameterValueLength;
            _emptyParameterValue = emptyParameterValue;
        }

        #region Functions
        private static IEnumerable<string> Union(IEnumerable<string> list1, IEnumerable<string> list2)
        {
            IEnumerable<string> response;

            if (list1 == null && list2 == null)
            {
                response = null;
            }
            else if (list1 == null)
            {
                response = list2.Distinct();
            }
            else if (list2 == null)
            {
                response = list1.Distinct();
            }
            else
            {
                response = list1.Union(list2);
            }

            return response;
        }

        private static bool IsMatch(int? field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(Convert.ToString(field.Value), expression, options);
        }

        private static bool IsMatch(string field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(field, expression, options);
        }

        // This is just context and tuple counts where they are integer values - easier that changing the parsing logic to just return the value
        private static int Count(int count)
        {
            return count;
        }


        private static int Count<T>(IEnumerable<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static int Count<T>(ICollection<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static bool exists(bool value)
        {
            return value;
        }

        private static string GetValueOrEmpty(bool? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        private static string GetValueOrEmpty(DateTime? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        /// <summary>
        /// Get string value between [first] a and [last] b.
        /// </summary>
        public static string Between(string value, string a, string b)
        {
            int posA = value.IndexOf(a);
            int posB = value.LastIndexOf(b);
            if (posA == -1)
            {
                return "";
            }
            if (posB == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= posB)
            {
                return "";
            }
            return value.Substring(adjustedPosA, posB - adjustedPosA);
        }

        /// <summary>
        /// Get string value after [first] a.
        /// </summary>
        public static string Before(string value, string a)
        {
            int posA = value.IndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            return value.Substring(0, posA);
        }

        /// <summary>
        /// Get string value after [last] a.
        /// </summary>
        public static string After(string value, string a)
        {
            int posA = value.LastIndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= value.Length)
            {
                return "";
            }
            return value.Substring(adjustedPosA);
        }

        private static int Length(object field)
        {
            if (field == null)
                return 0;
            else
                return field.ToString().Trim().Length;
        }

        private static bool NotSameValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return NotSameValues(nodesArray);
        }

        private static bool NotSameValues(params object[] nodes)
        {
            if (nodes == null)
                return false;

            return ((from x in nodes select x).Distinct().Count() == nodes.Count());
        }

        private static bool HasDuplicateValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return HasDuplicateValues(nodesArray);
        }

        private static bool HasDuplicateValues(params object[] nodes)
        {
            if (nodes == null)
                return false;

            return !((from x in nodes select x).Distinct().Count() == nodes.Count());
        }

        private int DuplicateValueIndex(IEnumerable<object> values)
        {
            int response = 0;
            var hashset = new HashSet<object>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private int DuplicateValueIndex<T>(IEnumerable<T?> values) where T : struct
        {
            int response = 0;
            var hashset = new HashSet<T?>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private static bool IsDate(object value)
        {
            DateTime dateValue;
            return (value != null && DateTime.TryParse(value.ToString(), out dateValue));
        }

        public DateTime AsDate(string dateAsString)
        {
            DateTime response = DateTime.MinValue;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date;
            }

            return response;
        }
        //The logic in After function expects "---" for day and "--" for month. 
        //Since hyphen was missing the date always returned null
        public DateTime? ConvertToDate(int day, int month, int year)
        {
            return ConvertToDate(day == 0 ? null : "---" + day.ToString(), month == 0 ? null : "--" + month.ToString(), year == 0 ? null : year.ToString());
        }

        public DateTime? ConvertToDate(string day, string month, string year)
        {
            DateTime? response;
            DateTime result;

            if (year == null || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        public DateTime? ConvertToDate(string day, string month, int year)
        {
            DateTime? response;
            DateTime result;

            if (year == 0 || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year.ToString() + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        private static int Day(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Day;
            }

            return response;
        }


        private static int Day(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Day;

        }


        private static string Month(string dateAsString)
        {
            string response = null;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.ToString("MMMM");
            }
            else
            {
                return "NotAMonth";
            }

            return response;
        }

        private static string Month(DateTime? date)
        {
            if (date == null)
                return "NotAMonth";
            else
                return date.Value.ToString("MMMM");
        }


        private static int MonthAsInt(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Month;
            }

            return response;
        }

        private static int MonthAsInt(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            return date.Value.Month;
        }


        private static int Year(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Year;
            }

            return response;
        }

        private static int Year(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Year;
        }


        private static int CurrentFinancialYear()
        {
            return DateToFinancialYear(DateTime.Now, 7);
        }

        private static int FinancialYear(string dateAsString)
        {
            return DateToFinancialYear(dateAsString, 7);
        }

        private static int FinancialYear(DateTime? date)
        {
            return DateToFinancialYear(date, 7);
        }

        private static int DateToFinancialYear(string dateAsString, int startingMonth)
        {
            int response = 0;
            DateTime date;
            if (DateTime.TryParse(dateAsString, out date))
            {
                response = DateToFinancialYear(date, startingMonth);
            }

            return response;
        }
        private static int DateToFinancialYear(DateTime? date, int startingMonth)
        {
            int response;
            if (date == null)
            {
                response = 0;
            }
            else
            {
                int year = date.Value.Year;
                int month = date.Value.Month;

                if (startingMonth > month)
                    response = year;
                else
                    response = year + 1;
            }
            return response;
        }


        private static int FBTYear(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
                response = FBTYear(date);
            return response;
        }

        private static int FBTYear(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            else
            {
                if (date.Value.Month > 3)
                    return date.Value.Year + 1;
                else
                    return date.Value.Year;
            }
        }


        private static bool IsNumeric(object value)
        {
            decimal numbervalue;
            return (value != null && decimal.TryParse(value.ToString(), out numbervalue));
        }

        private static bool NotMonetary(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(int? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }

        private static bool NotNumeric(long? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }


        private static bool OutsideRange(decimal field, decimal expression, int range)
        {
            bool response;

            response = (field < (expression - range)) || (field > (expression + range));

            return response;
        }


        private static bool FailsUSIAlgorithm(string usi, string abn)
        {
            bool response;
            if (usi == null || abn == null)
            {
                response = false;
            }
            else
            {
                usi = usi.Trim();
                abn = abn.Trim();
                if (usi.Length < 13 || abn.Length < 11)
                {
                    response = false;
                }
                else
                {
                    int numeric;
                    if (usi.Substring(0, 11) == abn && int.TryParse(usi.Substring(11, 2), out numeric))
                        response = false;
                    else if (Regex.IsMatch(usi, @"^[a-zA-Z]{3}\d{4}[a-zA-Z]{2}"))
                        response = false;
                    else
                        response = true;
                }
            }
            return response;
        }


        private static bool FailsTANAlgorithm(string tan)
        {
            bool response;
            decimal decimalTan;

            if (tan == null)
                return false;

            tan = tan.Trim();

            if (!decimal.TryParse(tan, out decimalTan))
                return true;

            if (tan.Length != 8)
                return true;

            decimal tanSum =
                7 * int.Parse(tan.Substring(0, 1)) +
                9 * int.Parse(tan.Substring(1, 1)) +
                8 * int.Parse(tan.Substring(2, 1)) +
                4 * int.Parse(tan.Substring(3, 1)) +
                6 * int.Parse(tan.Substring(4, 1)) +
                3 * int.Parse(tan.Substring(5, 1)) +
                5 * int.Parse(tan.Substring(6, 1)) +
                1 * int.Parse(tan.Substring(7, 1));

            if ((tanSum % 11) == 0)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsABNAlgorithm(string abn)
        {
            bool response;
            decimal decimalAbn;

            if (abn == null)
                return false;

            abn = abn.Trim();

            if (!decimal.TryParse(abn, out decimalAbn))
                return true;

            if (abn.Length != 11)
                return true;

            decimal abnSum =
                10 * (int.Parse(abn.Substring(0, 1)) - 1) +
                1 * int.Parse(abn.Substring(1, 1)) +
                3 * int.Parse(abn.Substring(2, 1)) +
                5 * int.Parse(abn.Substring(3, 1)) +
                7 * int.Parse(abn.Substring(4, 1)) +
                9 * int.Parse(abn.Substring(5, 1)) +
                11 * int.Parse(abn.Substring(6, 1)) +
                13 * int.Parse(abn.Substring(7, 1)) +
                15 * int.Parse(abn.Substring(8, 1)) +
                17 * int.Parse(abn.Substring(9, 1)) +
                19 * int.Parse(abn.Substring(10, 1));

            if ((abnSum % 89) == 0)
                response = false;
            else
                response = true;

            return response;
        }
        private static bool FailsACNAlgorithm(string acn)
        {
            bool response;
            decimal decimalAbn;
            if (acn == null)
                return false;

            acn = acn.Trim();

            if (!decimal.TryParse(acn, out decimalAbn))
                return true;

            if (acn.Length != 9)
                return true;

            decimal abnSum =
                8 * int.Parse(acn.Substring(0, 1)) +
                7 * int.Parse(acn.Substring(1, 1)) +
                6 * int.Parse(acn.Substring(2, 1)) +
                5 * int.Parse(acn.Substring(3, 1)) +
                4 * int.Parse(acn.Substring(4, 1)) +
                3 * int.Parse(acn.Substring(5, 1)) +
                2 * int.Parse(acn.Substring(6, 1)) +
                1 * int.Parse(acn.Substring(7, 1));

            decimal checkDigit = int.Parse(acn.Substring(8, 1));
            decimal acnRemainder = abnSum % 10;

            if (((10 - acnRemainder) % 10) == checkDigit)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsTFNAlgorithm(string tfn)
        {
            bool response;
            decimal decimalTfn;

            if (tfn == null)
                return false;

            tfn = tfn.Trim();
            tfn = Regex.Replace(tfn, "^0+", "");

            if (!decimal.TryParse(tfn, out decimalTfn))
                return true;

            if (tfn.Length < 8)
                return true;


            decimal tfn1To7Sum =
                1 * int.Parse(tfn.Substring(0, 1)) +
                4 * int.Parse(tfn.Substring(1, 1)) +
                3 * int.Parse(tfn.Substring(2, 1)) +
                7 * int.Parse(tfn.Substring(3, 1)) +
                5 * int.Parse(tfn.Substring(4, 1)) +
                8 * int.Parse(tfn.Substring(5, 1)) +
                6 * int.Parse(tfn.Substring(6, 1));

            decimal tfn8 = 9 * int.Parse(tfn.Substring(7, 1));

            if (tfn.Length == 8)
            {
                decimal tFNLg8WSum9 = 10 * int.Parse(tfn.Substring(7, 1));
                decimal tFNLg8WSum = tfn1To7Sum + tFNLg8WSum9;

                if ((tFNLg8WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else if (tfn.Length == 9)
            {
                decimal tfn9 = 10 * int.Parse(tfn.Substring(8, 1));
                decimal tFNLg9WSum = tfn1To7Sum + tfn8 + tfn9;

                if ((tFNLg9WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else
            {
                response = true;
            }

            return response;
        }


        private static decimal ConditionalValue(bool expression, decimal? trueVal, decimal? falseVal)
        {
            return expression ? trueVal.GetValueOrDefault() : falseVal.GetValueOrDefault();
        }

        private static decimal AsNumeric(string value)
        {
            decimal numberValue;
            decimal.TryParse(value, out numberValue);
            return numberValue;
        }

        private static bool RegexMatch(int? field, string expression, string flags = "")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static bool RegexMatch(string field, string expression, string flags = "")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static RegexOptions GetRegexOption(string flags)
        {
            RegexOptions options = RegexOptions.None;

            char[] characters = flags.ToCharArray();

            foreach (char character in characters)
            {
                switch (character)
                {
                    case 'i':
                        options = options | RegexOptions.IgnoreCase;
                        break;
                    case 'm':
                        options = options | RegexOptions.Multiline;
                        break;
                    case 's':
                        options = options | RegexOptions.Singleline;
                        break;
                    case 'n':
                        options = options | RegexOptions.ExplicitCapture;
                        break;
                    case 'x':
                        options = options | RegexOptions.IgnorePatternWhitespace;
                        break;
                }
            }

            return options;
        }

        /// <summary>
        /// Returns an occurrence index as [occurrenceIndex] of occurrenceIndex > 0, otherwise the empty string
        /// </summary>
        /// <param name="occurrenceIndex">Index of the occurrence.</param>
        /// <returns>Occurrence in XPath [#] format</returns>
        public string OccurrenceIndex(int occurrenceIndex)
        {
            return occurrenceIndex > 0 ? "[" + occurrenceIndex + "]" : "";
        }

        #endregion // Functions
        
        private static Dictionary<string, ProcessMessageDocument> _processMessageDocuments = new Dictionary<string, ProcessMessageDocument>();

        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        public List<ProcessMessageDocument> ValidateReport(EPMTSYSTXCLNTREQUEST2017 report)
        {

            List<ProcessMessageDocument> response = new List<ProcessMessageDocument>();
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            bool assertion;

            // ------------------------------------------------------------------------------
            // Validations are now done in code.
            // This version supports full validation of a report - for those rules that have successfully parsed and could be generated.
            // Generated Validations include:
            //   - Validation logic in C#.
            //   - Production of errors in EBMS, SBR and SWS format.
            // 
            // The generation at this stage does not support the following - and has to be completed manually (later versions of the generation will do this for you)
            //   - Business Rules that did not parse.  The ESR team will help support you where this happens as an effort is being made to rectify these
            //   - You will get TODO tasks for those that the parser could not cope with
            // ------------------------------------------------------------------------------


            #region VR.ATO.EPMTSYSTXCLNT.000005

            /*  VR.ATO.EPMTSYSTXCLNT.000005
            If Business's primary account holder first name, Business's primary account holder second name or Business's primary account holder date of birth is present, then the Business's primary account holder surname must be provided.
    
            Legacy Rule Format:
            (^EPMTSYSTXCLNT11 <> NULLORBLANK OR ^EPMTSYSTXCLNT12 <> NULLORBLANK OR ^EPMTSYSTXCLNT13 <> NULL) AND ^EPMTSYSTXCLNT10 = NULLORBLANK

            Technical Business Rule Format:
            (^EPMTSYSTXCLNT11 <> BLANK OR ^EPMTSYSTXCLNT12 <> BLANK OR ^EPMTSYSTXCLNT13 <> NULL) AND ^EPMTSYSTXCLNT10 = BLANK
    
            Data Elements:
    
            Business:^EPMTSYSTXCLNT10 = pyde.02.00:PersonNameDetails.FamilyName.Text
    
            Business:^EPMTSYSTXCLNT11 = pyde.02.00:PersonNameDetails.GivenName.Text
    
            Business:^EPMTSYSTXCLNT12 = pyde.02.00:PersonNameDetails.OtherGivenName.Text
    
            Business:^EPMTSYSTXCLNT13 = pyde.02.00:PersonDemographicDetails.Birth.Date
            */
            assertion = ((string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT11) != true || string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT12) != true || report.EPMTSYSTXCLNT13 != null) && string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT10) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000005",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"If First given name, Second given name or Date of birth is present, then the surname must be provided",
                    LongDescription = @"The Surname or Family Name must be present if either the First Given Name, Second Given Name or Date of Birth is present.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:PersonNameDetailsFamilyNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.000005" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT11", Value = report.EPMTSYSTXCLNT11 });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT12", Value = report.EPMTSYSTXCLNT12 });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT13", Value = GetValueOrEmpty(report.EPMTSYSTXCLNT13) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT10", Value = report.EPMTSYSTXCLNT10 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.000005

            #region VR.ATO.EPMTSYSTXCLNT.000045

            /*  VR.ATO.EPMTSYSTXCLNT.000045
            The Customer Reference Number must be provided.
    
            Legacy Rule Format:
            (^EPMTSYSTXCLNT1 = BLANK)

            Technical Business Rule Format:
            ^EPMTSYSTXCLNT1 = BLANK
    
            Data Elements:
    
            Business:^EPMTSYSTXCLNT1 = pyid.02.00:IdentificationDetails.IdentifierName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT1) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000053",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"This field must be provided",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:IdentificationDetailsIdentifierNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.000045" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT1", Value = report.EPMTSYSTXCLNT1 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.000045

            #region VR.ATO.EPMTSYSTXCLNT.000046

            /*  VR.ATO.EPMTSYSTXCLNT.000046
            A value must be provided in either the Business's primary account holder surname, Business's registered name or Business's trading name.
    
            Legacy Rule Format:
            (^EPMTSYSTXCLNT10 = NULLORBLANK AND ^EPMTSYSTXCLNT7 = NULLORBLANK AND ^EPMTSYSTXCLNT8 = NULLORBLANK)

            Technical Business Rule Format:
            ^EPMTSYSTXCLNT10 = BLANK AND ^EPMTSYSTXCLNT7 = BLANK AND ^EPMTSYSTXCLNT8 = BLANK
    
            Data Elements:
    
            Business:^EPMTSYSTXCLNT10 = pyde.02.00:PersonNameDetails.FamilyName.Text
    
            Business.MN:^EPMTSYSTXCLNT7 = pyde.02.00:OrganisationNameDetails.OrganisationalName.Text
    
            Business.MTR:^EPMTSYSTXCLNT8 = pyde.02.00:OrganisationNameDetails.OrganisationalName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT10) == true && string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT7) == true && string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT8) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000046",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Surname, Registered Name or Trading Name must be provided",
                    LongDescription = @"A value must be provided in either the Surname or Family Name field, Registered Name field or Trading Name field.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:PersonNameDetailsFamilyNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.000046" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT10", Value = report.EPMTSYSTXCLNT10 });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT7", Value = report.EPMTSYSTXCLNT7 });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT8", Value = report.EPMTSYSTXCLNT8 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.000046

            #region VR.ATO.EPMTSYSTXCLNT.W00001

            /*  VR.ATO.EPMTSYSTXCLNT.W00001
            The Business's Australian Business Number (ABN) has failed the ABN algorithm check.
    
            Legacy Rule Format:
            FailsABNAlgorithm(^EPMTSYSTXCLNT2)

            Technical Business Rule Format:
            FailsABNAlgorithm(^EPMTSYSTXCLNT2)
    
            Data Elements:
    
            Business:^EPMTSYSTXCLNT2 = pyid.02.00:Identifiers.AustralianBusinessNumber.Identifier
            */
            assertion = FailsABNAlgorithm(report.EPMTSYSTXCLNT2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000001",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Invalid ABN",
                    LongDescription = @"The provided ABN did not pass the Australian Business Number algorithm.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:IdentifiersAustralianBusinessNumberIdentifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00001" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT2", Value = report.EPMTSYSTXCLNT2 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00001

            #region VR.ATO.EPMTSYSTXCLNT.W00002

            /*  VR.ATO.EPMTSYSTXCLNT.W00002
            The Business's Australian Company Number (ACN) has failed the ACN algorithm check.
    
            Legacy Rule Format:
            FailsACNAlgorithm(^EPMTSYSTXCLNT3)

            Technical Business Rule Format:
            FailsACNAlgorithm(^EPMTSYSTXCLNT3)
    
            Data Elements:
    
            Business:^EPMTSYSTXCLNT3 = pyid.02.00:Identifiers.AustralianCompanyNumber.Identifier
            */
            assertion = FailsACNAlgorithm(report.EPMTSYSTXCLNT3);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000002",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Invalid ACN",
                    LongDescription = @"When provided, the Australian Company Number must be valid.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:IdentifiersAustralianCompanyNumberIdentifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00002" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT3", Value = report.EPMTSYSTXCLNT3 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00002

            #region VR.ATO.EPMTSYSTXCLNT.W00004

            /*  VR.ATO.EPMTSYSTXCLNT.W00004
            Invalid date. Payment facility commencement date cannot be any day in the future.
    
            Legacy Rule Format:
            ^EPMTSYSTXCLNT9 <> NULL AND ^EPMTSYSTXCLNT9 > Today()

            Technical Business Rule Format:
            ^EPMTSYSTXCLNT9 <> NULL AND ^EPMTSYSTXCLNT9 > Today()
    
            Data Elements:
    
            Business:^EPMTSYSTXCLNT9 = pyde.02.14:OrganisationDetails.RegistrationStart.Date
            */
            assertion = (report.EPMTSYSTXCLNT9 != null && report.EPMTSYSTXCLNT9.GetValueOrDefault() > DateTime.Now.Date);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000004",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Invalid date",
                    LongDescription = @"The date field must not contain a future date.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:OrganisationDetailsRegistrationStartDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00004" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT9", Value = GetValueOrEmpty(report.EPMTSYSTXCLNT9) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00004

            #region VR.ATO.EPMTSYSTXCLNT.W00007

            /*  VR.ATO.EPMTSYSTXCLNT.W00007
            Invalid date. Business's primary account holder date of birth cannot be any day in the future.
    
            Legacy Rule Format:
            ^EPMTSYSTXCLNT13 <> NULL AND ^EPMTSYSTXCLNT13 > Today()

            Technical Business Rule Format:
            ^EPMTSYSTXCLNT13 <> NULL AND ^EPMTSYSTXCLNT13 > Today()
    
            Data Elements:
    
            Business:^EPMTSYSTXCLNT13 = pyde.02.00:PersonDemographicDetails.Birth.Date
            */
            assertion = (report.EPMTSYSTXCLNT13 != null && report.EPMTSYSTXCLNT13.GetValueOrDefault() > DateTime.Now.Date);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000004",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Invalid date",
                    LongDescription = @"The date field must not contain a future date.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:PersonDemographicDetailsBirthDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00007" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT13", Value = GetValueOrEmpty(report.EPMTSYSTXCLNT13) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00007

            #region VR.ATO.EPMTSYSTXCLNT.W00009

            /*  VR.ATO.EPMTSYSTXCLNT.W00009
            If the business's contact phone number is an international phone number, the area code must not be provided.
    
            Legacy Rule Format:
            (^EPMTSYSTXCLNT48 = TRUE AND ^EPMTSYSTXCLNT15 <> NULL)

            Technical Business Rule Format:
            ^EPMTSYSTXCLNT48 = TRUE AND ^EPMTSYSTXCLNT15 <> NULL
    
            Data Elements:
    
            Business.PrimaryContact:^EPMTSYSTXCLNT15 = pyde.02.00:ElectronicContact.Telephone.Area.Code
    
            Business.AddressDetails.Business:^EPMTSYSTXCLNT48 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
            */
            assertion = (report.EPMTSYSTXCLNT48 == true && report.EPMTSYSTXCLNT15 != null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000009",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"This field must be left blank",
                    LongDescription = @"When the address is overseas, the Area Code must be blank.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:PrimaryContact/tns:ElectronicContactTelephoneAreaCode",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00009" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT48", Value = GetValueOrEmpty(report.EPMTSYSTXCLNT48) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT15", Value = report.EPMTSYSTXCLNT15 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00009

            #region VR.ATO.EPMTSYSTXCLNT.W00013

            /*  VR.ATO.EPMTSYSTXCLNT.W00013
            Either Primary account holder business address line one or  Primary account holder postal address line one must be provided.
    
            Legacy Rule Format:
            (^EPMTSYSTXCLNT18 = BLANK AND ^EPMTSYSTXCLNT24 =BLANK)

            Technical Business Rule Format:
            ^EPMTSYSTXCLNT18 = BLANK AND ^EPMTSYSTXCLNT24 =BLANK
    
            Data Elements:
    
            Business.AddressDetails.Business:^EPMTSYSTXCLNT18 = pyde.02.00:AddressDetails.Line1.Text
    
            Business.AddressDetails.Postal:^EPMTSYSTXCLNT24 = pyde.02.00:AddressDetails.Line1.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT18) == true && string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT24) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000013",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Either business address or postal address must be completed",
                    LongDescription = @"Either Street Address Line 1 or Postal Address Line 1 needs to be completed.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:AddressDetailsBusiness/tns:Line1Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00013" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT18", Value = report.EPMTSYSTXCLNT18 });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT24", Value = report.EPMTSYSTXCLNT24 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00013

            #region VR.ATO.EPMTSYSTXCLNT.W00014

            /*  VR.ATO.EPMTSYSTXCLNT.W00014
            Primary account holder business address line one must be provided.
    
            Legacy Rule Format:
            (^EPMTSYSTXCLNT18 = BLANK AND COUNT(Business.AddressDetails.Business) > 0)

            Technical Business Rule Format:
            (^EPMTSYSTXCLNT18 = BLANK AND Count(^Context) > 0)
    
            Data Elements:
    
            Business.AddressDetails.Business:^EPMTSYSTXCLNT18 = pyde.02.00:AddressDetails.Line1.Text
    
            Business.AddressDetails.Business:^Context = Business:Business.AddressDetails.Business
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT18) == true && Count(report.BusinessAddressDetailsBusinessCount) > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000014",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"This field must be provided",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:AddressDetailsBusiness/tns:Line1Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00014" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT18", Value = report.EPMTSYSTXCLNT18 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00014

            #region VR.ATO.EPMTSYSTXCLNT.W00019

            /*  VR.ATO.EPMTSYSTXCLNT.W00019
            Primary account holder business address suburb, town or locality must be provided.
    
            Legacy Rule Format:
            (^EPMTSYSTXCLNT20 = BLANK AND COUNT(Business.AddressDetails.Business) > 0)

            Technical Business Rule Format:
            (^EPMTSYSTXCLNT20 = BLANK AND Count(^Context) > 0)
    
            Data Elements:
    
            Business.AddressDetails.Business:^EPMTSYSTXCLNT20 = pyde.02.00:AddressDetails.LocalityName.Text
    
            Business.AddressDetails.Business:^Context = Business:Business.AddressDetails.Business
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT20) == true && Count(report.BusinessAddressDetailsBusinessCount) > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000014",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"This field must be provided",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:AddressDetailsBusiness/tns:LocalityNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00019" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT20", Value = report.EPMTSYSTXCLNT20 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00019

            #region VR.ATO.EPMTSYSTXCLNT.W00021

            /*  VR.ATO.EPMTSYSTXCLNT.W00021
            When the address is within Australia, the Postcode must be in the range of '0200-9998'.
    
            Legacy Rule Format:
            ((^EPMTSYSTXCLNT48 = FALSE AND (AsNumeric(^EPMTSYSTXCLNT23) < 200 OR AsNumeric(^EPMTSYSTXCLNT23) > 9998)) AND COUNT(Business.AddressDetails.Business) > 0)

            Technical Business Rule Format:
            ((^EPMTSYSTXCLNT48 = FALSE AND (AsNumeric(^EPMTSYSTXCLNT23) < 200 OR AsNumeric(^EPMTSYSTXCLNT23) > 9998)) AND Count(^Context) > 0)
    
            Data Elements:
    
            Business.AddressDetails.Business:^EPMTSYSTXCLNT23 = pyde.02.00:AddressDetails.Postcode.Text
    
            Business.AddressDetails.Business:^EPMTSYSTXCLNT48 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
    
            Business.AddressDetails.Business:^Context = Business:Business.AddressDetails.Business
            */
            assertion = (report.EPMTSYSTXCLNT48 == false && (AsNumeric(report.EPMTSYSTXCLNT23) < 200 || AsNumeric(report.EPMTSYSTXCLNT23) > 9998) && Count(report.BusinessAddressDetailsBusinessCount) > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000021",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"A valid postcode must be provided",
                    LongDescription = @"When the address is within Australia, the Postcode must be in the range of '0200-9998'.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:AddressDetailsBusiness/tns:PostcodeText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00021" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT48", Value = GetValueOrEmpty(report.EPMTSYSTXCLNT48) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT23", Value = report.EPMTSYSTXCLNT23 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00021

            #region VR.ATO.EPMTSYSTXCLNT.W00023

            /*  VR.ATO.EPMTSYSTXCLNT.W00023
            If Primary account holder business address is overseas, then primary account holder business post code must be blank.
    
            Legacy Rule Format:
            ((^EPMTSYSTXCLNT48 = TRUE AND ^EPMTSYSTXCLNT23 <> NULL) AND COUNT(Business.AddressDetails.Business) > 0)

            Technical Business Rule Format:
            ((^EPMTSYSTXCLNT48 = TRUE AND ^EPMTSYSTXCLNT23 <> NULL) AND Count(^Context) > 0)
    
            Data Elements:
    
            Business.AddressDetails.Business:^EPMTSYSTXCLNT23 = pyde.02.00:AddressDetails.Postcode.Text
    
            Business.AddressDetails.Business:^EPMTSYSTXCLNT48 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
    
            Business.AddressDetails.Business:^Context = Business:Business.AddressDetails.Business
            */
            assertion = (report.EPMTSYSTXCLNT48 == true && report.EPMTSYSTXCLNT23 != null && Count(report.BusinessAddressDetailsBusinessCount) > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000049",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"This field must be left blank",
                    LongDescription = @"When the address is overseas, the Postcode must be blank.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:AddressDetailsBusiness/tns:PostcodeText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00023" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT48", Value = GetValueOrEmpty(report.EPMTSYSTXCLNT48) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT23", Value = report.EPMTSYSTXCLNT23 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00023

            #region VR.ATO.EPMTSYSTXCLNT.W00024

            /*  VR.ATO.EPMTSYSTXCLNT.W00024
            If Primary account holder business address is an Australian address, the primary account holder business state or territory field must be set to one of the codes listed: ACT, NSW, NT, QLD, SA, TAS, VIC, WA.
    
            Legacy Rule Format:
            ((^EPMTSYSTXCLNT48 = FALSE AND NotInSet(^EPMTSYSTXCLNT22,'"ACT", "NSW", "NT", "QLD", "SA", "TAS", "VIC", "WA"')) AND COUNT(Business.AddressDetails.Business) > 0)

            Technical Business Rule Format:
            ((^EPMTSYSTXCLNT48 = FALSE AND NotInSet(^EPMTSYSTXCLNT22,'"ACT", "NSW", "NT", "QLD", "SA", "TAS", "VIC", "WA"')) AND Count(^Context) > 0)
    
            Data Elements:
    
            Business.AddressDetails.Business:^EPMTSYSTXCLNT22 = pyde.02.00:AddressDetails.StateOrTerritory.Code
    
            Business.AddressDetails.Business:^EPMTSYSTXCLNT48 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
    
            Business.AddressDetails.Business:^Context = Business:Business.AddressDetails.Business
            */
            assertion = (report.EPMTSYSTXCLNT48 == false && !(IsMatch(report.EPMTSYSTXCLNT22, @"^(ACT|NSW|NT|QLD|SA|TAS|VIC|WA)$", RegexOptions.IgnoreCase)) && Count(report.BusinessAddressDetailsBusinessCount) > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000024",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Invalid state/territory code",
                    LongDescription = @"When the address is within Australia, the State / Territory must be a valid state code.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:AddressDetailsBusiness/tns:StateOrTerritoryCode",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00024" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT48", Value = GetValueOrEmpty(report.EPMTSYSTXCLNT48) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT22", Value = report.EPMTSYSTXCLNT22 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00024

            #region VR.ATO.EPMTSYSTXCLNT.W00025

            /*  VR.ATO.EPMTSYSTXCLNT.W00025
            If Primary account holder business address is an overseas address, then primary account holder business state or territory must be blank.
    
            Legacy Rule Format:
            ((^EPMTSYSTXCLNT48 = TRUE AND ^EPMTSYSTXCLNT22 <> NULL) AND COUNT(Business.AddressDetails.Business) > 0)

            Technical Business Rule Format:
            ((^EPMTSYSTXCLNT48 = TRUE AND ^EPMTSYSTXCLNT22 <> NULL) AND Count(^Context) > 0)
    
            Data Elements:
    
            Business.AddressDetails.Business:^EPMTSYSTXCLNT22 = pyde.02.00:AddressDetails.StateOrTerritory.Code
    
            Business.AddressDetails.Business:^EPMTSYSTXCLNT48 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
    
            Business.AddressDetails.Business:^Context = Business:Business.AddressDetails.Business
            */
            assertion = (report.EPMTSYSTXCLNT48 == true && report.EPMTSYSTXCLNT22 != null && Count(report.BusinessAddressDetailsBusinessCount) > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000025",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"This field must be left blank",
                    LongDescription = @"When the address is overseas, the State / Territory must be blank.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:AddressDetailsBusiness/tns:StateOrTerritoryCode",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00025" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT48", Value = GetValueOrEmpty(report.EPMTSYSTXCLNT48) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT22", Value = report.EPMTSYSTXCLNT22 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00025

            #region VR.ATO.EPMTSYSTXCLNT.W00026

            /*  VR.ATO.EPMTSYSTXCLNT.W00026
            When the address is overseas, the Primary account holder business address country name cannot be 'AUSTRALIA' or blank.
    
            Legacy Rule Format:
            (( ^EPMTSYSTXCLNT48 = TRUE AND ((^EPMTSYSTXCLNT21 = NULLORBLANK) OR RegexMatch(^EPMTSYSTXCLNT21, '^\s*AUSTRALIA\s*$', 'i'))) AND COUNT(Business.AddressDetails.Business) > 0)

            Technical Business Rule Format:
            ((^EPMTSYSTXCLNT48 = TRUE AND ((^EPMTSYSTXCLNT21 = BLANK) OR RegexMatch(^EPMTSYSTXCLNT21, '^\s*AUSTRALIA\s*$', 'i'))) AND Count(^Context) > 0)
    
            Data Elements:
    
            Business.AddressDetails.Business:^EPMTSYSTXCLNT21 = pyde.02.08:AddressDetails.CountryName.Text
    
            Business.AddressDetails.Business:^EPMTSYSTXCLNT48 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
    
            Business.AddressDetails.Business:^Context = Business:Business.AddressDetails.Business
            */
            assertion = (report.EPMTSYSTXCLNT48 == true && (string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT21) == true || RegexMatch(report.EPMTSYSTXCLNT21, @"^\s*AUSTRALIA\s*$", @"i")) && Count(report.BusinessAddressDetailsBusinessCount) > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000026",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"A country other than Australia must be entered",
                    LongDescription = @"When the address is overseas, the Country Name cannot be 'AUSTRALIA' or blank.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:AddressDetailsBusiness/tns:CountryNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00026" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT48", Value = GetValueOrEmpty(report.EPMTSYSTXCLNT48) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT21", Value = report.EPMTSYSTXCLNT21 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00026

            #region VR.ATO.EPMTSYSTXCLNT.W00028

            /*  VR.ATO.EPMTSYSTXCLNT.W00028
            Primary account holder postal address line one must be provided.
    
            Legacy Rule Format:
            (^EPMTSYSTXCLNT24 = BLANK AND COUNT(Business.AddressDetails.Postal) > 0)

            Technical Business Rule Format:
            (^EPMTSYSTXCLNT24 = BLANK AND Count(^Context) > 0)
    
            Data Elements:
    
            Business.AddressDetails.Postal:^EPMTSYSTXCLNT24 = pyde.02.00:AddressDetails.Line1.Text
    
            Business.AddressDetails.Postal:^Context = Business:Business.AddressDetails.Postal
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT24) == true && Count(report.BusinessAddressDetailsPostalCount) > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000014",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"This field must be provided",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:AddressDetailsPostal/tns:Line1Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00028" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT24", Value = report.EPMTSYSTXCLNT24 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00028

            #region VR.ATO.EPMTSYSTXCLNT.W00033

            /*  VR.ATO.EPMTSYSTXCLNT.W00033
            Primary account holder postal address suburb, town or locality must be provided.
    
            Legacy Rule Format:
            (^EPMTSYSTXCLNT26 = BLANK AND COUNT(Business.AddressDetails.Postal) > 0)

            Technical Business Rule Format:
            (^EPMTSYSTXCLNT26 = BLANK AND Count(^Context) > 0)
    
            Data Elements:
    
            Business.AddressDetails.Postal:^EPMTSYSTXCLNT26 = pyde.02.00:AddressDetails.LocalityName.Text
    
            Business.AddressDetails.Postal:^Context = Business:Business.AddressDetails.Postal
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT26) == true && Count(report.BusinessAddressDetailsPostalCount) > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000014",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"This field must be provided",
                    LongDescription = @"The field must be entered but you did not report anything in this field.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:AddressDetailsPostal/tns:LocalityNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00033" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT26", Value = report.EPMTSYSTXCLNT26 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00033

            #region VR.ATO.EPMTSYSTXCLNT.W00034

            /*  VR.ATO.EPMTSYSTXCLNT.W00034
            When the address is within Australia, the Postcode must be in the range of '0200-9998'.
    
            Legacy Rule Format:
            ((^EPMTSYSTXCLNT49 = false AND (AsNumeric(^EPMTSYSTXCLNT29) < 200 OR AsNumeric(^EPMTSYSTXCLNT29) > 9998)) AND COUNT(Business.AddressDetails.Postal) > 0)

            Technical Business Rule Format:
            ((^EPMTSYSTXCLNT49 = false AND (AsNumeric(^EPMTSYSTXCLNT29) < 200 OR AsNumeric(^EPMTSYSTXCLNT29) > 9998)) AND Count(^Context) > 0)
    
            Data Elements:
    
            Business.AddressDetails.Postal:^EPMTSYSTXCLNT29 = pyde.02.00:AddressDetails.Postcode.Text
    
            Business.AddressDetails.Postal:^EPMTSYSTXCLNT49 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
    
            Business.AddressDetails.Postal:^Context = Business:Business.AddressDetails.Postal
            */
            assertion = (report.EPMTSYSTXCLNT49 == false && (AsNumeric(report.EPMTSYSTXCLNT29) < 200 || AsNumeric(report.EPMTSYSTXCLNT29) > 9998) && Count(report.BusinessAddressDetailsPostalCount) > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000021",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"A valid postcode must be provided",
                    LongDescription = @"When the address is within Australia, the Postcode must be in the range of '0200-9998'.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:AddressDetailsPostal/tns:PostcodeText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00034" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT49", Value = GetValueOrEmpty(report.EPMTSYSTXCLNT49) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT29", Value = report.EPMTSYSTXCLNT29 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00034

            #region VR.ATO.EPMTSYSTXCLNT.W00036

            /*  VR.ATO.EPMTSYSTXCLNT.W00036
            If Primary account holder postal address is an Australian address, the primary account holder postal state or territory field must be set to one of the codes listed: ACT, NSW, NT, QLD, SA, TAS, VIC, WA.
    
            Legacy Rule Format:
            ((^EPMTSYSTXCLNT49 = FALSE AND NotInSet(^EPMTSYSTXCLNT28,'"ACT", "NSW", "NT", "QLD", "SA", "TAS", "VIC", "WA"')) AND COUNT(Business.AddressDetails.Postal) > 0)

            Technical Business Rule Format:
            ((^EPMTSYSTXCLNT49 = FALSE AND NotInSet(^EPMTSYSTXCLNT28,'"ACT", "NSW", "NT", "QLD", "SA", "TAS", "VIC", "WA"')) AND Count(^Context) > 0)
    
            Data Elements:
    
            Business.AddressDetails.Postal:^EPMTSYSTXCLNT28 = pyde.02.00:AddressDetails.StateOrTerritory.Code
    
            Business.AddressDetails.Postal:^EPMTSYSTXCLNT49 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
    
            Business.AddressDetails.Postal:^Context = Business:Business.AddressDetails.Postal
            */
            assertion = (report.EPMTSYSTXCLNT49 == false && !(IsMatch(report.EPMTSYSTXCLNT28, @"^(ACT|NSW|NT|QLD|SA|TAS|VIC|WA)$", RegexOptions.IgnoreCase)) && Count(report.BusinessAddressDetailsPostalCount) > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000024",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Invalid state/territory code",
                    LongDescription = @"When the address is within Australia, the State / Territory must be a valid state code.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:AddressDetailsPostal/tns:StateOrTerritoryCode",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00036" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT49", Value = GetValueOrEmpty(report.EPMTSYSTXCLNT49) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT28", Value = report.EPMTSYSTXCLNT28 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00036

            #region VR.ATO.EPMTSYSTXCLNT.W00037

            /*  VR.ATO.EPMTSYSTXCLNT.W00037
            When the address is overseas, the Primary account holder postal address country name cannot be 'AUSTRALIA' or blank.
    
            Legacy Rule Format:
            (COUNT(Business.AddressDetails.Postal) > 0 AND ^EPMTSYSTXCLNT49 = TRUE AND (^EPMTSYSTXCLNT27 = NULLORBLANK OR RegexMatch(^EPMTSYSTXCLNT27, '^\s*AUSTRALIA\s*$', 'i')))

            Technical Business Rule Format:
            (Count(^Context) > 0 AND ^EPMTSYSTXCLNT49 = TRUE AND (^EPMTSYSTXCLNT27 = BLANK OR RegexMatch(^EPMTSYSTXCLNT27, '^\s*AUSTRALIA\s*$', 'i')))
    
            Data Elements:
    
            Business.AddressDetails.Postal:^EPMTSYSTXCLNT27 = pyde.02.08:AddressDetails.CountryName.Text
    
            Business.AddressDetails.Postal:^EPMTSYSTXCLNT49 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
    
            Business.AddressDetails.Postal:^Context = Business:Business.AddressDetails.Postal
            */
            assertion = (Count(report.BusinessAddressDetailsPostalCount) > 0 && report.EPMTSYSTXCLNT49 == true && (string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT27) == true || RegexMatch(report.EPMTSYSTXCLNT27, @"^\s*AUSTRALIA\s*$", @"i")));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000026",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"A country other than Australia must be entered",
                    LongDescription = @"When the address is overseas, the Country Name cannot be 'AUSTRALIA' or blank.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:AddressDetailsPostal/tns:CountryNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00037" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT49", Value = GetValueOrEmpty(report.EPMTSYSTXCLNT49) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT27", Value = report.EPMTSYSTXCLNT27 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00037

            #region VR.ATO.EPMTSYSTXCLNT.W00047

            /*  VR.ATO.EPMTSYSTXCLNT.W00047
            If provided, must be a valid format.
    
            Legacy Rule Format:
            (^EPMTSYSTXCLNT17 <> NULLORBLANK AND NOT IsValidEmail(^EPMTSYSTXCLNT17))

            Technical Business Rule Format:
            (^EPMTSYSTXCLNT17 <> BLANK AND NOT IsValidEmail(^EPMTSYSTXCLNT17))
    
            Data Elements:
    
            Business.PrimaryContact:^EPMTSYSTXCLNT17 = pyde.02.00:ElectronicContact.ElectronicMail.Address.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT17) != true && !(IsMatch(report.EPMTSYSTXCLNT17, @"^\S.*@.+\.\S+$")));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000047",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"If provided, must be a valid format",
                    LongDescription = @"The part of an email address before the @ symbol generally consists of letters and digits and may also include some special characters. The part after the @ symbol generally consists of letters, digits, hyphens and dots only. This part must include a dot, but must not start or end with a dot.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:PrimaryContact/tns:ElectronicContactElectronicMailAddressText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00047" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT17", Value = report.EPMTSYSTXCLNT17 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00047

            #region VR.ATO.EPMTSYSTXCLNT.W00048

            /*  VR.ATO.EPMTSYSTXCLNT.W00048
            When the address is within Australia, the Country Name must be 'AUSTRALIA' or blank.
    
            Legacy Rule Format:
            COUNT(Business.AddressDetails.Business) > 0 AND ^EPMTSYSTXCLNT48 = false AND (^EPMTSYSTXCLNT21 <> NULLORBLANK AND NOT RegexMatch(^EPMTSYSTXCLNT21, '^\s*AUSTRALIA\s*$', 'i'))

            Technical Business Rule Format:
            Count(^Context) > 0 AND ^EPMTSYSTXCLNT48 = false AND (^EPMTSYSTXCLNT21 <> BLANK AND NOT RegexMatch(^EPMTSYSTXCLNT21, '^\s*AUSTRALIA\s*$', 'i'))
    
            Data Elements:
    
            Business.AddressDetails.Business:^EPMTSYSTXCLNT21 = pyde.02.08:AddressDetails.CountryName.Text
    
            Business.AddressDetails.Business:^EPMTSYSTXCLNT48 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
    
            Business.AddressDetails.Business:^Context = Business:Business.AddressDetails.Business
            */
            assertion = (Count(report.BusinessAddressDetailsBusinessCount) > 0 && report.EPMTSYSTXCLNT48 == false && (string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT21) != true && !(RegexMatch(report.EPMTSYSTXCLNT21, @"^\s*AUSTRALIA\s*$", @"i"))));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000048",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Either 'AUSTRALIA' must be provided or left blank",
                    LongDescription = @"When the address is within Australia, the Country Name must be 'AUSTRALIA' or blank.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:AddressDetailsBusiness/tns:CountryNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00048" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT48", Value = GetValueOrEmpty(report.EPMTSYSTXCLNT48) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT21", Value = report.EPMTSYSTXCLNT21 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00048

            #region VR.ATO.EPMTSYSTXCLNT.W00049

            /*  VR.ATO.EPMTSYSTXCLNT.W00049
            If Primary account holder postal address is overseas, then primary account holder postal post code must be blank.
    
            Legacy Rule Format:
            ((^EPMTSYSTXCLNT49 = TRUE AND ^EPMTSYSTXCLNT29 <> NULL) AND COUNT(Business.AddressDetails.Postal) > 0)

            Technical Business Rule Format:
            ((^EPMTSYSTXCLNT49 = TRUE AND ^EPMTSYSTXCLNT29 <> NULL) AND Count(^Context) > 0)
    
            Data Elements:
    
            Business.AddressDetails.Postal:^EPMTSYSTXCLNT29 = pyde.02.00:AddressDetails.Postcode.Text
    
            Business.AddressDetails.Postal:^EPMTSYSTXCLNT49 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
    
            Business.AddressDetails.Postal:^Context = Business:Business.AddressDetails.Postal
            */
            assertion = (report.EPMTSYSTXCLNT49 == true && report.EPMTSYSTXCLNT29 != null && Count(report.BusinessAddressDetailsPostalCount) > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000049",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"This field must be left blank",
                    LongDescription = @"When the address is overseas, the Postcode must be blank.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:AddressDetailsPostal/tns:PostcodeText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00049" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT49", Value = GetValueOrEmpty(report.EPMTSYSTXCLNT49) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT29", Value = report.EPMTSYSTXCLNT29 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00049

            #region VR.ATO.EPMTSYSTXCLNT.W00050

            /*  VR.ATO.EPMTSYSTXCLNT.W00050
            If Primary account holder postal address is an overseas address, then primary account holder postal state or territory must be blank.
    
            Legacy Rule Format:
            ((^EPMTSYSTXCLNT49 = TRUE AND ^EPMTSYSTXCLNT28 <> NULL) AND COUNT(Business.AddressDetails.Postal) > 0)

            Technical Business Rule Format:
            ((^EPMTSYSTXCLNT49 = TRUE AND ^EPMTSYSTXCLNT28 <> NULL) AND Count(^Context) > 0)
    
            Data Elements:
    
            Business.AddressDetails.Postal:^EPMTSYSTXCLNT28 = pyde.02.00:AddressDetails.StateOrTerritory.Code
    
            Business.AddressDetails.Postal:^EPMTSYSTXCLNT49 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
    
            Business.AddressDetails.Postal:^Context = Business:Business.AddressDetails.Postal
            */
            assertion = (report.EPMTSYSTXCLNT49 == true && report.EPMTSYSTXCLNT28 != null && Count(report.BusinessAddressDetailsPostalCount) > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000025",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"This field must be left blank",
                    LongDescription = @"When the address is overseas, the State / Territory must be blank.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:AddressDetailsPostal/tns:StateOrTerritoryCode",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00050" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT49", Value = GetValueOrEmpty(report.EPMTSYSTXCLNT49) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT28", Value = report.EPMTSYSTXCLNT28 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00050

            #region VR.ATO.EPMTSYSTXCLNT.W00051

            /*  VR.ATO.EPMTSYSTXCLNT.W00051
            When the address is within Australia, the Country Name must be 'AUSTRALIA' or blank.
    
            Legacy Rule Format:
            COUNT(Business.AddressDetails.Postal) > 0 AND ^EPMTSYSTXCLNT49 = false AND (^EPMTSYSTXCLNT27 <> NULLORBLANK AND NOT RegexMatch(^EPMTSYSTXCLNT27, '^\s*AUSTRALIA\s*$', 'i'))

            Technical Business Rule Format:
            Count(^Context) > 0 AND ^EPMTSYSTXCLNT49 = false AND (^EPMTSYSTXCLNT27 <> BLANK AND NOT RegexMatch(^EPMTSYSTXCLNT27, '^\s*AUSTRALIA\s*$', 'i'))
    
            Data Elements:
    
            Business.AddressDetails.Postal:^EPMTSYSTXCLNT27 = pyde.02.08:AddressDetails.CountryName.Text
    
            Business.AddressDetails.Postal:^EPMTSYSTXCLNT49 = pyde.02.00:AddressDetails.OverseasAddress.Indicator
    
            Business.AddressDetails.Postal:^Context = Business:Business.AddressDetails.Postal
            */
            assertion = (Count(report.BusinessAddressDetailsPostalCount) > 0 && report.EPMTSYSTXCLNT49 == false && (string.IsNullOrWhiteSpace(report.EPMTSYSTXCLNT27) != true && !(RegexMatch(report.EPMTSYSTXCLNT27, @"^\s*AUSTRALIA\s*$", @"i"))));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.EPMTSYSTXCLNT.000048",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Either 'AUSTRALIA' must be provided or left blank",
                    LongDescription = @"When the address is within Australia, the Country Name must be 'AUSTRALIA' or blank.",
                    Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:AddressDetailsPostal/tns:CountryNameText",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00051" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT49", Value = GetValueOrEmpty(report.EPMTSYSTXCLNT49) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "EPMTSYSTXCLNT27", Value = report.EPMTSYSTXCLNT27 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.EPMTSYSTXCLNT.W00051

            #region Repeating report.BusinessReportingPeriodCollection
            if (report.BusinessReportingPeriodCollection != null)
            {
                int itemIndex1 = 0;
                foreach (EPMTSYSTXCLNTREQUEST2017.BusinessReportingPeriod businessReportingPeriod in report.BusinessReportingPeriodCollection)
                {
                    itemIndex1++;

                    #region VR.ATO.EPMTSYSTXCLNT.000039

                    /*  VR.ATO.EPMTSYSTXCLNT.000039
                    Invalid date. Transaction period end date must be equal or greater than the transaction period start date.
    
                    Legacy Rule Format:
                    ^EPMTSYSTXCLNT34 < ^EPMTSYSTXCLNT33
        
                    Technical Business Rule Format:
                    ^EPMTSYSTXCLNT34 < ^EPMTSYSTXCLNT33
            
                    Data Elements:
            
                    Business:^EPMTSYSTXCLNT34 = pyin.02.00:Period.End.Date
            
                    Business:^EPMTSYSTXCLNT33 = pyin.02.00:Period.Start.Date
                    */
                    assertion = (businessReportingPeriod.EPMTSYSTXCLNT34.GetValueOrDefault() < businessReportingPeriod.EPMTSYSTXCLNT33.GetValueOrDefault());
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.EPMTSYSTXCLNT.000039",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Transaction period end date is invalid",
                            LongDescription = @"The date reported in the Transaction Period End Date must be on or after the date reported in the Transaction Period Start Date field.",
                            Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:BusinessReportingPeriodCollection/tns:BusinessReportingPeriod[" + itemIndex1 + "]/tns:PeriodEndDate",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.000039" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "EPMTSYSTXCLNT34", Value = GetValueOrEmpty(businessReportingPeriod.EPMTSYSTXCLNT34) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "EPMTSYSTXCLNT33", Value = GetValueOrEmpty(businessReportingPeriod.EPMTSYSTXCLNT33) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.EPMTSYSTXCLNT.000039

                    #region VR.ATO.EPMTSYSTXCLNT.000040

                    /*  VR.ATO.EPMTSYSTXCLNT.000040
                    Invalid date. Transaction period end date must be within the same month as the date reported in the Transaction period start date.
    
                    Legacy Rule Format:
                    MonthAsInt(^EPMTSYSTXCLNT34) <> MonthAsInt(^EPMTSYSTXCLNT33)
        
                    Technical Business Rule Format:
                    MonthAsInt(^EPMTSYSTXCLNT34) <> MonthAsInt(^EPMTSYSTXCLNT33)
            
                    Data Elements:
            
                    Business:^EPMTSYSTXCLNT34 = pyin.02.00:Period.End.Date
            
                    Business:^EPMTSYSTXCLNT33 = pyin.02.00:Period.Start.Date
                    */
                    assertion = (MonthAsInt(businessReportingPeriod.EPMTSYSTXCLNT34.GetValueOrDefault()) != MonthAsInt(businessReportingPeriod.EPMTSYSTXCLNT33.GetValueOrDefault()));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.EPMTSYSTXCLNT.000040",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Transaction period end date is invalid",
                            LongDescription = @"The date reported in the Transaction Period End Date must be in the same month as the date reported in the Transaction Period Start Date field.",
                            Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:BusinessReportingPeriodCollection/tns:BusinessReportingPeriod[" + itemIndex1 + "]/tns:PeriodEndDate",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.000040" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "EPMTSYSTXCLNT34", Value = GetValueOrEmpty(businessReportingPeriod.EPMTSYSTXCLNT34) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "EPMTSYSTXCLNT33", Value = GetValueOrEmpty(businessReportingPeriod.EPMTSYSTXCLNT33) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.EPMTSYSTXCLNT.000040

                    #region VR.ATO.EPMTSYSTXCLNT.000042

                    /*  VR.ATO.EPMTSYSTXCLNT.000042
                    Bank/State/Branch number invalid. Valid range is 012000 - 999999.
    
                    Legacy Rule Format:
                    (AsNumeric(^EPMTSYSTXCLNT30) < 12000 OR AsNumeric(^EPMTSYSTXCLNT30) > 999999)
        
                    Technical Business Rule Format:
                    (AsNumeric(^EPMTSYSTXCLNT30) < 12000 OR AsNumeric(^EPMTSYSTXCLNT30) > 999999)
            
                    Data Elements:
            
                    Business:^EPMTSYSTXCLNT30 = pyid.02.00:FinancialInstitutionAccount.BankStateBranch.Number
                    */
                    assertion = (AsNumeric(businessReportingPeriod.EPMTSYSTXCLNT30) < 12000 || AsNumeric(businessReportingPeriod.EPMTSYSTXCLNT30) > 999999);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.EPMTSYSTXCLNT.000042",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Invalid BSB",
                            LongDescription = @"Must be a valid BSB number.",
                            Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:BusinessReportingPeriodCollection/tns:BusinessReportingPeriod[" + itemIndex1 + "]/tns:FinancialInstitutionAccountBankStateBranchNumber",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.000042" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "EPMTSYSTXCLNT30", Value = businessReportingPeriod.EPMTSYSTXCLNT30 });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.EPMTSYSTXCLNT.000042

                    #region VR.ATO.EPMTSYSTXCLNT.000047

                    /*  VR.ATO.EPMTSYSTXCLNT.000047
                    Business reporting period customer reference number must equal the business details customer reference number.
    
                    Legacy Rule Format:
                    (^EPMTSYSTXCLNT47 <> ^EPMTSYSTXCLNT1)
        
                    Technical Business Rule Format:
                    ^EPMTSYSTXCLNT47 <> ^EPMTSYSTXCLNT1
            
                    Data Elements:
            
                    Business:^EPMTSYSTXCLNT47 = pyid.02.00:IdentificationDetails.IdentifierName.Text
            
                    Business:^EPMTSYSTXCLNT1 = pyid.02.00:IdentificationDetails.IdentifierName.Text
                    */
                    assertion = (businessReportingPeriod.EPMTSYSTXCLNT47 != report.EPMTSYSTXCLNT1);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.EPMTSYSTXCLNT.000054",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Customer reference number invalid",
                            LongDescription = @"The business reporting period customer reference number must be the same as business details customer reference number.",
                            Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:BusinessReportingPeriodCollection/tns:BusinessReportingPeriod[" + itemIndex1 + "]/tns:IdentificationDetailsIdentifierNameText",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.000047" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "EPMTSYSTXCLNT47", Value = businessReportingPeriod.EPMTSYSTXCLNT47 });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "EPMTSYSTXCLNT1", Value = report.EPMTSYSTXCLNT1 });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.EPMTSYSTXCLNT.000047

                    #region VR.ATO.EPMTSYSTXCLNT.000056

                    /*  VR.ATO.EPMTSYSTXCLNT.000056
                    Payment system description must be provided.
    
                    Legacy Rule Format:
                    (^EPMTSYSTXCLNT45 = BLANK)
        
                    Technical Business Rule Format:
                    ^EPMTSYSTXCLNT45 = BLANK
            
                    Data Elements:
            
                    Business:^EPMTSYSTXCLNT45 = pyin.02.33:PaymentMechanism.PaymentMethod.Description
                    */
                    assertion = (string.IsNullOrWhiteSpace(businessReportingPeriod.EPMTSYSTXCLNT45) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.EPMTSYSTXCLNT.000053",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"This field must be provided",
                            LongDescription = @"The field must be entered but you did not report anything in this field.",
                            Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:BusinessReportingPeriodCollection/tns:BusinessReportingPeriod[" + itemIndex1 + "]/tns:PaymentMechanismPaymentMethodDescription",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.000056" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "EPMTSYSTXCLNT45", Value = businessReportingPeriod.EPMTSYSTXCLNT45 });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.EPMTSYSTXCLNT.000056

                    #region VR.ATO.EPMTSYSTXCLNT.000057

                    /*  VR.ATO.EPMTSYSTXCLNT.000057
                    Payment system account number must be provided.
    
                    Legacy Rule Format:
                    (^EPMTSYSTXCLNT46 = BLANK)
        
                    Technical Business Rule Format:
                    ^EPMTSYSTXCLNT46 = BLANK
            
                    Data Elements:
            
                    Business:^EPMTSYSTXCLNT46 = pyin.02.40:PaymentMechanism.Account.Number
                    */
                    assertion = (string.IsNullOrWhiteSpace(businessReportingPeriod.EPMTSYSTXCLNT46) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.EPMTSYSTXCLNT.000053",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"This field must be provided",
                            LongDescription = @"The field must be entered but you did not report anything in this field.",
                            Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:BusinessReportingPeriodCollection/tns:BusinessReportingPeriod[" + itemIndex1 + "]/tns:PaymentMechanismAccountNumber",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.000057" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "EPMTSYSTXCLNT46", Value = businessReportingPeriod.EPMTSYSTXCLNT46 });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.EPMTSYSTXCLNT.000057

                    #region VR.ATO.EPMTSYSTXCLNT.000058

                    /*  VR.ATO.EPMTSYSTXCLNT.000058
                    Business's settlement account number must be provided.
    
                    Legacy Rule Format:
                    (^EPMTSYSTXCLNT31 = BLANK)
        
                    Technical Business Rule Format:
                    ^EPMTSYSTXCLNT31 = BLANK
            
                    Data Elements:
            
                    Business:^EPMTSYSTXCLNT31 = pyid.02.00:FinancialInstitutionAccount.FinancialInstitutionAccount.Number
                    */
                    assertion = (string.IsNullOrWhiteSpace(businessReportingPeriod.EPMTSYSTXCLNT31) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.EPMTSYSTXCLNT.000053",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"This field must be provided",
                            LongDescription = @"The field must be entered but you did not report anything in this field.",
                            Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:BusinessReportingPeriodCollection/tns:BusinessReportingPeriod[" + itemIndex1 + "]/tns:FinancialInstitutionAccountFinancialInstitutionAccountNumber",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.000058" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "EPMTSYSTXCLNT31", Value = businessReportingPeriod.EPMTSYSTXCLNT31 });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.EPMTSYSTXCLNT.000058

                    #region VR.ATO.EPMTSYSTXCLNT.W00041

                    /*  VR.ATO.EPMTSYSTXCLNT.W00041
                    The currency of the transactions being reported must be valid.
    
                    Legacy Rule Format:
                    NotInSet(^EPMTSYSTXCLNT44,'"AFN","EUR","ALL","DZD","USD","EUR","AOA","XCD","ARS","AMD","AWG","AUD","EUR","AZN","BSD","BHD","BDT","BBD","BYR","EUR","BZD","XOF","BMD","BTN","INR","BOB","BOV","USD","BAM","BWP","NOK","BRL","USD","BND","BGN","XOF","BIF","CVE","KHR","XAF","CAD","KYD","XAF","XAF","CLF","CLP","CNY","AUD","AUD","COP","COU","KMF","CDF","XAF","NZD","CRC","XOF","HRK","CUC","CUP","ANG","EUR","CZK","DKK","DJF","XCD","DOP","USD","EGP","SVC","USD","XAF","ERN","EUR","ETB","EUR","FKP","DKK","FJD","EUR","EUR","EUR","XPF","EUR","XAF","GMD","GEL","EUR","GHS","GIP","EUR","DKK","XCD","EUR","USD","GTQ","GBP","GNF","XOF","GYD","HTG","USD","AUD","EUR","HNL","HKD","HUF","ISK","INR","IDR","XDR","IRR","IQD","EUR","GBP","ILS","EUR","JMD","JPY","GBP","JOD","KZT","KES","AUD","KPW","KRW","KWD","KGS","LAK","EUR","LBP","LSL","ZAR","LRD","LYD","CHF","EUR","EUR","MOP","MKD","MGA","MWK","MYR","MVR","XOF","EUR","USD","EUR","MRO","MUR","EUR","XUA","MXN","MXV","USD","MDL","EUR","MNT","EUR","XCD","MAD","MZN","MMK","NAD","ZAR","AUD","NPR","EUR","XPF","NZD","NIO","XOF","NGN","NZD","AUD","USD","NOK","OMR","PKR","USD","PAB","USD","PGK","PYG","PEN","PHP","NZD","PLN","EUR","USD","QAR","EUR","RON","RUB","RWF","EUR","SHP","XCD","XCD","EUR","EUR","XCD","WST","EUR","STD","SAR","XOF","RSD","SCR","SLL","SGD","ANG","XSU","EUR","EUR","SBD","SOS","ZAR","SSP","EUR","LKR","SDG","SRD","NOK","SZL","SEK","CHE","CHF","CHW","SYP","TWD","TJS","TZS","THB","USD","XOF","NZD","TOP","TTD","TND","TRY","TMT","USD","AUD","UGX","UAH","AED","GBP","USD","USD","USN","UYI","UYU","UZS","VUV","VEF","VND","USD","USD","XPF","MAD","YER","ZMW","ZWL","XBA","XBB","XBC","XBD","XTS","XXX","XAU","XPD","XPT","XAG"')
        
                    Technical Business Rule Format:
                    NotInSet(^EPMTSYSTXCLNT44,'"AFN","EUR","ALL","DZD","USD","EUR","AOA","XCD","ARS","AMD","AWG","AUD","EUR","AZN","BSD","BHD","BDT","BBD","BYR","EUR","BZD","XOF","BMD","BTN","INR","BOB","BOV","USD","BAM","BWP","NOK","BRL","USD","BND","BGN","XOF","BIF","CVE","KHR","XAF","CAD","KYD","XAF","XAF","CLF","CLP","CNY","AUD","AUD","COP","COU","KMF","CDF","XAF","NZD","CRC","XOF","HRK","CUC","CUP","ANG","EUR","CZK","DKK","DJF","XCD","DOP","USD","EGP","SVC","USD","XAF","ERN","EUR","ETB","EUR","FKP","DKK","FJD","EUR","EUR","EUR","XPF","EUR","XAF","GMD","GEL","EUR","GHS","GIP","EUR","DKK","XCD","EUR","USD","GTQ","GBP","GNF","XOF","GYD","HTG","USD","AUD","EUR","HNL","HKD","HUF","ISK","INR","IDR","XDR","IRR","IQD","EUR","GBP","ILS","EUR","JMD","JPY","GBP","JOD","KZT","KES","AUD","KPW","KRW","KWD","KGS","LAK","EUR","LBP","LSL","ZAR","LRD","LYD","CHF","EUR","EUR","MOP","MKD","MGA","MWK","MYR","MVR","XOF","EUR","USD","EUR","MRO","MUR","EUR","XUA","MXN","MXV","USD","MDL","EUR","MNT","EUR","XCD","MAD","MZN","MMK","NAD","ZAR","AUD","NPR","EUR","XPF","NZD","NIO","XOF","NGN","NZD","AUD","USD","NOK","OMR","PKR","USD","PAB","USD","PGK","PYG","PEN","PHP","NZD","PLN","EUR","USD","QAR","EUR","RON","RUB","RWF","EUR","SHP","XCD","XCD","EUR","EUR","XCD","WST","EUR","STD","SAR","XOF","RSD","SCR","SLL","SGD","ANG","XSU","EUR","EUR","SBD","SOS","ZAR","SSP","EUR","LKR","SDG","SRD","NOK","SZL","SEK","CHE","CHF","CHW","SYP","TWD","TJS","TZS","THB","USD","XOF","NZD","TOP","TTD","TND","TRY","TMT","USD","AUD","UGX","UAH","AED","GBP","USD","USD","USN","UYI","UYU","UZS","VUV","VEF","VND","USD","USD","XPF","MAD","YER","ZMW","ZWL","XBA","XBB","XBC","XBD","XTS","XXX","XAU","XPD","XPT","XAG"')
            
                    Data Elements:
            
                    Business:^EPMTSYSTXCLNT44 = bafot.02.28:Miscellaneous.FunctionalCurrency.Text
                    */
                    assertion = !(IsMatch(businessReportingPeriod.EPMTSYSTXCLNT44, @"^(AFN|EUR|ALL|DZD|USD|EUR|AOA|XCD|ARS|AMD|AWG|AUD|EUR|AZN|BSD|BHD|BDT|BBD|BYR|EUR|BZD|XOF|BMD|BTN|INR|BOB|BOV|USD|BAM|BWP|NOK|BRL|USD|BND|BGN|XOF|BIF|CVE|KHR|XAF|CAD|KYD|XAF|XAF|CLF|CLP|CNY|AUD|AUD|COP|COU|KMF|CDF|XAF|NZD|CRC|XOF|HRK|CUC|CUP|ANG|EUR|CZK|DKK|DJF|XCD|DOP|USD|EGP|SVC|USD|XAF|ERN|EUR|ETB|EUR|FKP|DKK|FJD|EUR|EUR|EUR|XPF|EUR|XAF|GMD|GEL|EUR|GHS|GIP|EUR|DKK|XCD|EUR|USD|GTQ|GBP|GNF|XOF|GYD|HTG|USD|AUD|EUR|HNL|HKD|HUF|ISK|INR|IDR|XDR|IRR|IQD|EUR|GBP|ILS|EUR|JMD|JPY|GBP|JOD|KZT|KES|AUD|KPW|KRW|KWD|KGS|LAK|EUR|LBP|LSL|ZAR|LRD|LYD|CHF|EUR|EUR|MOP|MKD|MGA|MWK|MYR|MVR|XOF|EUR|USD|EUR|MRO|MUR|EUR|XUA|MXN|MXV|USD|MDL|EUR|MNT|EUR|XCD|MAD|MZN|MMK|NAD|ZAR|AUD|NPR|EUR|XPF|NZD|NIO|XOF|NGN|NZD|AUD|USD|NOK|OMR|PKR|USD|PAB|USD|PGK|PYG|PEN|PHP|NZD|PLN|EUR|USD|QAR|EUR|RON|RUB|RWF|EUR|SHP|XCD|XCD|EUR|EUR|XCD|WST|EUR|STD|SAR|XOF|RSD|SCR|SLL|SGD|ANG|XSU|EUR|EUR|SBD|SOS|ZAR|SSP|EUR|LKR|SDG|SRD|NOK|SZL|SEK|CHE|CHF|CHW|SYP|TWD|TJS|TZS|THB|USD|XOF|NZD|TOP|TTD|TND|TRY|TMT|USD|AUD|UGX|UAH|AED|GBP|USD|USD|USN|UYI|UYU|UZS|VUV|VEF|VND|USD|USD|XPF|MAD|YER|ZMW|ZWL|XBA|XBB|XBC|XBD|XTS|XXX|XAU|XPD|XPT|XAG)$", RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.EPMTSYSTXCLNT.000041",
                            Severity = ProcessMessageSeverity.Warning,
                            Description = @"The currency must be valid",
                            LongDescription = @"The Transaction Currency field must contain a valid currency code.",
                            Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:BusinessReportingPeriodCollection/tns:BusinessReportingPeriod[" + itemIndex1 + "]/tns:MiscellaneousFunctionalCurrencyText",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00041" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "EPMTSYSTXCLNT44", Value = businessReportingPeriod.EPMTSYSTXCLNT44 });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.EPMTSYSTXCLNT.W00041

                    #region VR.ATO.EPMTSYSTXCLNT.W00052

                    /*  VR.ATO.EPMTSYSTXCLNT.W00052
                    Field format incorrect. Exceeds maximum digits, decimals and/or contains illegal characters.  Do not include cents.
    
                    Legacy Rule Format:
                    NotNumeric(^EPMTSYSTXCLNT35, 'U',13,0)
        
                    Technical Business Rule Format:
                    NotNumeric(^EPMTSYSTXCLNT35, 'U',13,0)
            
                    Data Elements:
            
                    Business:^EPMTSYSTXCLNT35 = bafpr1.02.04:Income.Gross.Amount
                    */
                    assertion = NotNumeric(businessReportingPeriod.EPMTSYSTXCLNT35, @"U", 13, 0);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.EPMTSYSTXCLNT.000052",
                            Severity = ProcessMessageSeverity.Warning,
                            Description = @"Invalid format",
                            LongDescription = @"Must be reported in whole dollars only. Decimals have been truncated.",
                            Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:BusinessReportingPeriodCollection/tns:BusinessReportingPeriod[" + itemIndex1 + "]/tns:IncomeGrossAmount",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00052" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "EPMTSYSTXCLNT35", Value = businessReportingPeriod.EPMTSYSTXCLNT35.GetValueOrDefault().ToString() });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.EPMTSYSTXCLNT.W00052

                    #region VR.ATO.EPMTSYSTXCLNT.W00053

                    /*  VR.ATO.EPMTSYSTXCLNT.W00053
                    Field format incorrect. Exceeds maximum digits, decimals and/or contains illegal characters.  Do not include cents.
    
                    Legacy Rule Format:
                    NotNumeric(^EPMTSYSTXCLNT37, 'U',13,0)
        
                    Technical Business Rule Format:
                    NotNumeric(^EPMTSYSTXCLNT37, 'U',13,0)
            
                    Data Elements:
            
                    Business:^EPMTSYSTXCLNT37 = bafpr2.02.23:Income.SaleOfGoodsAndServices.TransactionRefund.Amount
                    */
                    assertion = NotNumeric(businessReportingPeriod.EPMTSYSTXCLNT37, @"U", 13, 0);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.EPMTSYSTXCLNT.000052",
                            Severity = ProcessMessageSeverity.Warning,
                            Description = @"Invalid format",
                            LongDescription = @"Must be reported in whole dollars only. Decimals have been truncated.",
                            Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:BusinessReportingPeriodCollection/tns:BusinessReportingPeriod[" + itemIndex1 + "]/tns:IncomeSaleOfGoodsAndServicesTransactionRefundAmount",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00053" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "EPMTSYSTXCLNT37", Value = businessReportingPeriod.EPMTSYSTXCLNT37.GetValueOrDefault().ToString() });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.EPMTSYSTXCLNT.W00053

                    #region VR.ATO.EPMTSYSTXCLNT.W00054

                    /*  VR.ATO.EPMTSYSTXCLNT.W00054
                    Field format incorrect. Exceeds maximum digits, decimals and/or contains illegal characters.  Do not include cents.
    
                    Legacy Rule Format:
                    NotNumeric(^EPMTSYSTXCLNT39, 'U',13,0)
        
                    Technical Business Rule Format:
                    NotNumeric(^EPMTSYSTXCLNT39, 'U',13,0)
            
                    Data Elements:
            
                    Business:^EPMTSYSTXCLNT39 = bafpr2.02.23:Income.SaleOfGoodsAndServices.TransactionCashOutOnly.Amount
                    */
                    assertion = NotNumeric(businessReportingPeriod.EPMTSYSTXCLNT39, @"U", 13, 0);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.EPMTSYSTXCLNT.000052",
                            Severity = ProcessMessageSeverity.Warning,
                            Description = @"Invalid format",
                            LongDescription = @"Must be reported in whole dollars only. Decimals have been truncated.",
                            Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:BusinessReportingPeriodCollection/tns:BusinessReportingPeriod[" + itemIndex1 + "]/tns:IncomeSaleOfGoodsAndServicesTransactionCashOutOnlyAmount",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00054" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "EPMTSYSTXCLNT39", Value = businessReportingPeriod.EPMTSYSTXCLNT39.GetValueOrDefault().ToString() });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.EPMTSYSTXCLNT.W00054

                    #region VR.ATO.EPMTSYSTXCLNT.W00055

                    /*  VR.ATO.EPMTSYSTXCLNT.W00055
                    Field format incorrect. Exceeds maximum digits, decimals and/or contains illegal characters.  Do not include cents.
    
                    Legacy Rule Format:
                    NotNumeric(^EPMTSYSTXCLNT41, 'U',13,0)
        
                    Technical Business Rule Format:
                    NotNumeric(^EPMTSYSTXCLNT41, 'U',13,0)
            
                    Data Elements:
            
                    Business:^EPMTSYSTXCLNT41 = bafpr2.02.23:Income.SaleOfGoodsAndServices.TransactionCashOutComponent.Amount
                    */
                    assertion = NotNumeric(businessReportingPeriod.EPMTSYSTXCLNT41, @"U", 13, 0);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.EPMTSYSTXCLNT.000052",
                            Severity = ProcessMessageSeverity.Warning,
                            Description = @"Invalid format",
                            LongDescription = @"Must be reported in whole dollars only. Decimals have been truncated.",
                            Location = "/tns:EPMTSYSTXCLNTREQUEST/tns:Business/tns:BusinessReportingPeriodCollection/tns:BusinessReportingPeriod[" + itemIndex1 + "]/tns:IncomeSaleOfGoodsAndServicesTransactionCashOutComponentAmount",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.EPMTSYSTXCLNT.W00055" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "EPMTSYSTXCLNT41", Value = businessReportingPeriod.EPMTSYSTXCLNT41.GetValueOrDefault().ToString() });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.EPMTSYSTXCLNT.W00055
                }
            }

            #endregion // Foreach loop

            foreach (ProcessMessageDocument currentProcessMessage in response)
            {
                if (currentProcessMessage.Parameters != null)
                {
                    foreach (ProcessMessageParameter currentParameter in currentProcessMessage.Parameters)
                    {
                        if (string.IsNullOrEmpty(currentParameter.Name))
                        {
                            currentParameter.Name = _emptyParameterValue;
                        }

                        if (currentParameter.Name.Length > _maxParameterNameLength)
                        {
                            currentParameter.Name = currentParameter.Name.Substring(0, _maxParameterNameLength - 1);
                        }

                        if (string.IsNullOrEmpty(currentParameter.Value))
                        {
                            currentParameter.Value = _emptyParameterValue;
                        }

                        if (currentParameter.Value.Length > _maxParameterValueLength)
                        {
                            currentParameter.Value = currentParameter.Value.Substring(0, _maxParameterValueLength - 1);
                        }
                    }
                }
            }

            return response;
        }


    }
}
